// SPDX-License-Identifier: MIT
// Copyright (C) 2018-present iced project and contributors

// ⚠️This file was generated by GENERATOR!🦹‍♂️

package com.github.icedland.iced.x86;

/**
 * Registers passed to {@code Instruction.create()} methods.
 *
 * @see ICRegistersGPR
 * @see ICRegistersVec
 * @see ICRegistersGPR8
 * @see ICRegistersGPR16
 * @see ICRegistersGPR32
 * @see ICRegistersGPR64
 * @see ICRegistersIP
 * @see ICRegistersSegment
 * @see ICRegistersST
 * @see ICRegistersCR
 * @see ICRegistersDR
 * @see ICRegistersTR
 * @see ICRegistersBND
 * @see ICRegistersK
 * @see ICRegistersMM
 * @see ICRegistersXMM
 * @see ICRegistersYMM
 * @see ICRegistersZMM
 * @see ICRegistersTMM
 */
public final class ICRegisters {
	private ICRegisters() {
	}

	public static final ICRegister al = new ICRegister(Register.AL);
	public static final ICRegister cl = new ICRegister(Register.CL);
	public static final ICRegister dl = new ICRegister(Register.DL);
	public static final ICRegister bl = new ICRegister(Register.BL);
	public static final ICRegister ah = new ICRegister(Register.AH);
	public static final ICRegister ch = new ICRegister(Register.CH);
	public static final ICRegister dh = new ICRegister(Register.DH);
	public static final ICRegister bh = new ICRegister(Register.BH);
	public static final ICRegister spl = new ICRegister(Register.SPL);
	public static final ICRegister bpl = new ICRegister(Register.BPL);
	public static final ICRegister sil = new ICRegister(Register.SIL);
	public static final ICRegister dil = new ICRegister(Register.DIL);
	public static final ICRegister r8b = new ICRegister(Register.R8L);
	public static final ICRegister r9b = new ICRegister(Register.R9L);
	public static final ICRegister r10b = new ICRegister(Register.R10L);
	public static final ICRegister r11b = new ICRegister(Register.R11L);
	public static final ICRegister r12b = new ICRegister(Register.R12L);
	public static final ICRegister r13b = new ICRegister(Register.R13L);
	public static final ICRegister r14b = new ICRegister(Register.R14L);
	public static final ICRegister r15b = new ICRegister(Register.R15L);
	public static final ICRegister ax = new ICRegister(Register.AX);
	public static final ICRegister cx = new ICRegister(Register.CX);
	public static final ICRegister dx = new ICRegister(Register.DX);
	public static final ICRegister bx = new ICRegister(Register.BX);
	public static final ICRegister sp = new ICRegister(Register.SP);
	public static final ICRegister bp = new ICRegister(Register.BP);
	public static final ICRegister si = new ICRegister(Register.SI);
	public static final ICRegister di = new ICRegister(Register.DI);
	public static final ICRegister r8w = new ICRegister(Register.R8W);
	public static final ICRegister r9w = new ICRegister(Register.R9W);
	public static final ICRegister r10w = new ICRegister(Register.R10W);
	public static final ICRegister r11w = new ICRegister(Register.R11W);
	public static final ICRegister r12w = new ICRegister(Register.R12W);
	public static final ICRegister r13w = new ICRegister(Register.R13W);
	public static final ICRegister r14w = new ICRegister(Register.R14W);
	public static final ICRegister r15w = new ICRegister(Register.R15W);
	public static final ICRegister eax = new ICRegister(Register.EAX);
	public static final ICRegister ecx = new ICRegister(Register.ECX);
	public static final ICRegister edx = new ICRegister(Register.EDX);
	public static final ICRegister ebx = new ICRegister(Register.EBX);
	public static final ICRegister esp = new ICRegister(Register.ESP);
	public static final ICRegister ebp = new ICRegister(Register.EBP);
	public static final ICRegister esi = new ICRegister(Register.ESI);
	public static final ICRegister edi = new ICRegister(Register.EDI);
	public static final ICRegister r8d = new ICRegister(Register.R8D);
	public static final ICRegister r9d = new ICRegister(Register.R9D);
	public static final ICRegister r10d = new ICRegister(Register.R10D);
	public static final ICRegister r11d = new ICRegister(Register.R11D);
	public static final ICRegister r12d = new ICRegister(Register.R12D);
	public static final ICRegister r13d = new ICRegister(Register.R13D);
	public static final ICRegister r14d = new ICRegister(Register.R14D);
	public static final ICRegister r15d = new ICRegister(Register.R15D);
	public static final ICRegister rax = new ICRegister(Register.RAX);
	public static final ICRegister rcx = new ICRegister(Register.RCX);
	public static final ICRegister rdx = new ICRegister(Register.RDX);
	public static final ICRegister rbx = new ICRegister(Register.RBX);
	public static final ICRegister rsp = new ICRegister(Register.RSP);
	public static final ICRegister rbp = new ICRegister(Register.RBP);
	public static final ICRegister rsi = new ICRegister(Register.RSI);
	public static final ICRegister rdi = new ICRegister(Register.RDI);
	public static final ICRegister r8 = new ICRegister(Register.R8);
	public static final ICRegister r9 = new ICRegister(Register.R9);
	public static final ICRegister r10 = new ICRegister(Register.R10);
	public static final ICRegister r11 = new ICRegister(Register.R11);
	public static final ICRegister r12 = new ICRegister(Register.R12);
	public static final ICRegister r13 = new ICRegister(Register.R13);
	public static final ICRegister r14 = new ICRegister(Register.R14);
	public static final ICRegister r15 = new ICRegister(Register.R15);
	public static final ICRegister eip = new ICRegister(Register.EIP);
	public static final ICRegister rip = new ICRegister(Register.RIP);
	public static final ICRegister es = new ICRegister(Register.ES);
	public static final ICRegister cs = new ICRegister(Register.CS);
	public static final ICRegister ss = new ICRegister(Register.SS);
	public static final ICRegister ds = new ICRegister(Register.DS);
	public static final ICRegister fs = new ICRegister(Register.FS);
	public static final ICRegister gs = new ICRegister(Register.GS);
	public static final ICRegister st0 = new ICRegister(Register.ST0);
	public static final ICRegister st1 = new ICRegister(Register.ST1);
	public static final ICRegister st2 = new ICRegister(Register.ST2);
	public static final ICRegister st3 = new ICRegister(Register.ST3);
	public static final ICRegister st4 = new ICRegister(Register.ST4);
	public static final ICRegister st5 = new ICRegister(Register.ST5);
	public static final ICRegister st6 = new ICRegister(Register.ST6);
	public static final ICRegister st7 = new ICRegister(Register.ST7);
	public static final ICRegister cr0 = new ICRegister(Register.CR0);
	public static final ICRegister cr1 = new ICRegister(Register.CR1);
	public static final ICRegister cr2 = new ICRegister(Register.CR2);
	public static final ICRegister cr3 = new ICRegister(Register.CR3);
	public static final ICRegister cr4 = new ICRegister(Register.CR4);
	public static final ICRegister cr5 = new ICRegister(Register.CR5);
	public static final ICRegister cr6 = new ICRegister(Register.CR6);
	public static final ICRegister cr7 = new ICRegister(Register.CR7);
	public static final ICRegister cr8 = new ICRegister(Register.CR8);
	public static final ICRegister cr9 = new ICRegister(Register.CR9);
	public static final ICRegister cr10 = new ICRegister(Register.CR10);
	public static final ICRegister cr11 = new ICRegister(Register.CR11);
	public static final ICRegister cr12 = new ICRegister(Register.CR12);
	public static final ICRegister cr13 = new ICRegister(Register.CR13);
	public static final ICRegister cr14 = new ICRegister(Register.CR14);
	public static final ICRegister cr15 = new ICRegister(Register.CR15);
	public static final ICRegister dr0 = new ICRegister(Register.DR0);
	public static final ICRegister dr1 = new ICRegister(Register.DR1);
	public static final ICRegister dr2 = new ICRegister(Register.DR2);
	public static final ICRegister dr3 = new ICRegister(Register.DR3);
	public static final ICRegister dr4 = new ICRegister(Register.DR4);
	public static final ICRegister dr5 = new ICRegister(Register.DR5);
	public static final ICRegister dr6 = new ICRegister(Register.DR6);
	public static final ICRegister dr7 = new ICRegister(Register.DR7);
	public static final ICRegister dr8 = new ICRegister(Register.DR8);
	public static final ICRegister dr9 = new ICRegister(Register.DR9);
	public static final ICRegister dr10 = new ICRegister(Register.DR10);
	public static final ICRegister dr11 = new ICRegister(Register.DR11);
	public static final ICRegister dr12 = new ICRegister(Register.DR12);
	public static final ICRegister dr13 = new ICRegister(Register.DR13);
	public static final ICRegister dr14 = new ICRegister(Register.DR14);
	public static final ICRegister dr15 = new ICRegister(Register.DR15);
	public static final ICRegister tr0 = new ICRegister(Register.TR0);
	public static final ICRegister tr1 = new ICRegister(Register.TR1);
	public static final ICRegister tr2 = new ICRegister(Register.TR2);
	public static final ICRegister tr3 = new ICRegister(Register.TR3);
	public static final ICRegister tr4 = new ICRegister(Register.TR4);
	public static final ICRegister tr5 = new ICRegister(Register.TR5);
	public static final ICRegister tr6 = new ICRegister(Register.TR6);
	public static final ICRegister tr7 = new ICRegister(Register.TR7);
	public static final ICRegister bnd0 = new ICRegister(Register.BND0);
	public static final ICRegister bnd1 = new ICRegister(Register.BND1);
	public static final ICRegister bnd2 = new ICRegister(Register.BND2);
	public static final ICRegister bnd3 = new ICRegister(Register.BND3);
	public static final ICRegister k0 = new ICRegister(Register.K0);
	public static final ICRegister k1 = new ICRegister(Register.K1);
	public static final ICRegister k2 = new ICRegister(Register.K2);
	public static final ICRegister k3 = new ICRegister(Register.K3);
	public static final ICRegister k4 = new ICRegister(Register.K4);
	public static final ICRegister k5 = new ICRegister(Register.K5);
	public static final ICRegister k6 = new ICRegister(Register.K6);
	public static final ICRegister k7 = new ICRegister(Register.K7);
	public static final ICRegister mm0 = new ICRegister(Register.MM0);
	public static final ICRegister mm1 = new ICRegister(Register.MM1);
	public static final ICRegister mm2 = new ICRegister(Register.MM2);
	public static final ICRegister mm3 = new ICRegister(Register.MM3);
	public static final ICRegister mm4 = new ICRegister(Register.MM4);
	public static final ICRegister mm5 = new ICRegister(Register.MM5);
	public static final ICRegister mm6 = new ICRegister(Register.MM6);
	public static final ICRegister mm7 = new ICRegister(Register.MM7);
	public static final ICRegister xmm0 = new ICRegister(Register.XMM0);
	public static final ICRegister xmm1 = new ICRegister(Register.XMM1);
	public static final ICRegister xmm2 = new ICRegister(Register.XMM2);
	public static final ICRegister xmm3 = new ICRegister(Register.XMM3);
	public static final ICRegister xmm4 = new ICRegister(Register.XMM4);
	public static final ICRegister xmm5 = new ICRegister(Register.XMM5);
	public static final ICRegister xmm6 = new ICRegister(Register.XMM6);
	public static final ICRegister xmm7 = new ICRegister(Register.XMM7);
	public static final ICRegister xmm8 = new ICRegister(Register.XMM8);
	public static final ICRegister xmm9 = new ICRegister(Register.XMM9);
	public static final ICRegister xmm10 = new ICRegister(Register.XMM10);
	public static final ICRegister xmm11 = new ICRegister(Register.XMM11);
	public static final ICRegister xmm12 = new ICRegister(Register.XMM12);
	public static final ICRegister xmm13 = new ICRegister(Register.XMM13);
	public static final ICRegister xmm14 = new ICRegister(Register.XMM14);
	public static final ICRegister xmm15 = new ICRegister(Register.XMM15);
	public static final ICRegister xmm16 = new ICRegister(Register.XMM16);
	public static final ICRegister xmm17 = new ICRegister(Register.XMM17);
	public static final ICRegister xmm18 = new ICRegister(Register.XMM18);
	public static final ICRegister xmm19 = new ICRegister(Register.XMM19);
	public static final ICRegister xmm20 = new ICRegister(Register.XMM20);
	public static final ICRegister xmm21 = new ICRegister(Register.XMM21);
	public static final ICRegister xmm22 = new ICRegister(Register.XMM22);
	public static final ICRegister xmm23 = new ICRegister(Register.XMM23);
	public static final ICRegister xmm24 = new ICRegister(Register.XMM24);
	public static final ICRegister xmm25 = new ICRegister(Register.XMM25);
	public static final ICRegister xmm26 = new ICRegister(Register.XMM26);
	public static final ICRegister xmm27 = new ICRegister(Register.XMM27);
	public static final ICRegister xmm28 = new ICRegister(Register.XMM28);
	public static final ICRegister xmm29 = new ICRegister(Register.XMM29);
	public static final ICRegister xmm30 = new ICRegister(Register.XMM30);
	public static final ICRegister xmm31 = new ICRegister(Register.XMM31);
	public static final ICRegister ymm0 = new ICRegister(Register.YMM0);
	public static final ICRegister ymm1 = new ICRegister(Register.YMM1);
	public static final ICRegister ymm2 = new ICRegister(Register.YMM2);
	public static final ICRegister ymm3 = new ICRegister(Register.YMM3);
	public static final ICRegister ymm4 = new ICRegister(Register.YMM4);
	public static final ICRegister ymm5 = new ICRegister(Register.YMM5);
	public static final ICRegister ymm6 = new ICRegister(Register.YMM6);
	public static final ICRegister ymm7 = new ICRegister(Register.YMM7);
	public static final ICRegister ymm8 = new ICRegister(Register.YMM8);
	public static final ICRegister ymm9 = new ICRegister(Register.YMM9);
	public static final ICRegister ymm10 = new ICRegister(Register.YMM10);
	public static final ICRegister ymm11 = new ICRegister(Register.YMM11);
	public static final ICRegister ymm12 = new ICRegister(Register.YMM12);
	public static final ICRegister ymm13 = new ICRegister(Register.YMM13);
	public static final ICRegister ymm14 = new ICRegister(Register.YMM14);
	public static final ICRegister ymm15 = new ICRegister(Register.YMM15);
	public static final ICRegister ymm16 = new ICRegister(Register.YMM16);
	public static final ICRegister ymm17 = new ICRegister(Register.YMM17);
	public static final ICRegister ymm18 = new ICRegister(Register.YMM18);
	public static final ICRegister ymm19 = new ICRegister(Register.YMM19);
	public static final ICRegister ymm20 = new ICRegister(Register.YMM20);
	public static final ICRegister ymm21 = new ICRegister(Register.YMM21);
	public static final ICRegister ymm22 = new ICRegister(Register.YMM22);
	public static final ICRegister ymm23 = new ICRegister(Register.YMM23);
	public static final ICRegister ymm24 = new ICRegister(Register.YMM24);
	public static final ICRegister ymm25 = new ICRegister(Register.YMM25);
	public static final ICRegister ymm26 = new ICRegister(Register.YMM26);
	public static final ICRegister ymm27 = new ICRegister(Register.YMM27);
	public static final ICRegister ymm28 = new ICRegister(Register.YMM28);
	public static final ICRegister ymm29 = new ICRegister(Register.YMM29);
	public static final ICRegister ymm30 = new ICRegister(Register.YMM30);
	public static final ICRegister ymm31 = new ICRegister(Register.YMM31);
	public static final ICRegister zmm0 = new ICRegister(Register.ZMM0);
	public static final ICRegister zmm1 = new ICRegister(Register.ZMM1);
	public static final ICRegister zmm2 = new ICRegister(Register.ZMM2);
	public static final ICRegister zmm3 = new ICRegister(Register.ZMM3);
	public static final ICRegister zmm4 = new ICRegister(Register.ZMM4);
	public static final ICRegister zmm5 = new ICRegister(Register.ZMM5);
	public static final ICRegister zmm6 = new ICRegister(Register.ZMM6);
	public static final ICRegister zmm7 = new ICRegister(Register.ZMM7);
	public static final ICRegister zmm8 = new ICRegister(Register.ZMM8);
	public static final ICRegister zmm9 = new ICRegister(Register.ZMM9);
	public static final ICRegister zmm10 = new ICRegister(Register.ZMM10);
	public static final ICRegister zmm11 = new ICRegister(Register.ZMM11);
	public static final ICRegister zmm12 = new ICRegister(Register.ZMM12);
	public static final ICRegister zmm13 = new ICRegister(Register.ZMM13);
	public static final ICRegister zmm14 = new ICRegister(Register.ZMM14);
	public static final ICRegister zmm15 = new ICRegister(Register.ZMM15);
	public static final ICRegister zmm16 = new ICRegister(Register.ZMM16);
	public static final ICRegister zmm17 = new ICRegister(Register.ZMM17);
	public static final ICRegister zmm18 = new ICRegister(Register.ZMM18);
	public static final ICRegister zmm19 = new ICRegister(Register.ZMM19);
	public static final ICRegister zmm20 = new ICRegister(Register.ZMM20);
	public static final ICRegister zmm21 = new ICRegister(Register.ZMM21);
	public static final ICRegister zmm22 = new ICRegister(Register.ZMM22);
	public static final ICRegister zmm23 = new ICRegister(Register.ZMM23);
	public static final ICRegister zmm24 = new ICRegister(Register.ZMM24);
	public static final ICRegister zmm25 = new ICRegister(Register.ZMM25);
	public static final ICRegister zmm26 = new ICRegister(Register.ZMM26);
	public static final ICRegister zmm27 = new ICRegister(Register.ZMM27);
	public static final ICRegister zmm28 = new ICRegister(Register.ZMM28);
	public static final ICRegister zmm29 = new ICRegister(Register.ZMM29);
	public static final ICRegister zmm30 = new ICRegister(Register.ZMM30);
	public static final ICRegister zmm31 = new ICRegister(Register.ZMM31);
	public static final ICRegister tmm0 = new ICRegister(Register.TMM0);
	public static final ICRegister tmm1 = new ICRegister(Register.TMM1);
	public static final ICRegister tmm2 = new ICRegister(Register.TMM2);
	public static final ICRegister tmm3 = new ICRegister(Register.TMM3);
	public static final ICRegister tmm4 = new ICRegister(Register.TMM4);
	public static final ICRegister tmm5 = new ICRegister(Register.TMM5);
	public static final ICRegister tmm6 = new ICRegister(Register.TMM6);
	public static final ICRegister tmm7 = new ICRegister(Register.TMM7);
}
