// SPDX-License-Identifier: MIT
// Copyright (C) 2018-present iced project and contributors

// ⚠️This file was generated by GENERATOR!🦹‍♂️

package com.github.icedland.iced.x86;

import java.util.HashMap;

public final class ToMnemonic {
	public static Integer tryGet(String key) {
		return map.get(key);
	}

	public static int get(String key) {
		Integer value = tryGet(key);
		if (value == null)
			throw new UnsupportedOperationException(String.format("Couldn't find enum variant Mnemonic.%s", key));
		return value.intValue();
	}

	public static String[] names() {
		return map.entrySet().stream().sorted((a, b) -> Integer.compareUnsigned(a.getValue(), b.getValue())).map(a -> a.getKey()).toArray(String[]::new);
	}

	public static Iterable<Integer> values() {
		return map.values();
	}

	public static int size() {
		return map.size();
	}

	public static HashMap<String, Integer> copy() {
		return new HashMap<String, Integer>(map);
	}

	private static final HashMap<String, Integer> map = getMap();

	private static HashMap<String, Integer> getMap() {
		HashMap<String, Integer> map = new HashMap<String, Integer>(1877);
		initMap0(map);
		initMap1(map);
		initMap2(map);
		initMap3(map);
		return map;
	}

	private static void initMap0(HashMap<String, Integer> map) {
		map.put("INVALID", Mnemonic.INVALID);
		map.put("Aaa", Mnemonic.AAA);
		map.put("Aad", Mnemonic.AAD);
		map.put("Aam", Mnemonic.AAM);
		map.put("Aas", Mnemonic.AAS);
		map.put("Adc", Mnemonic.ADC);
		map.put("Adcx", Mnemonic.ADCX);
		map.put("Add", Mnemonic.ADD);
		map.put("Addpd", Mnemonic.ADDPD);
		map.put("Addps", Mnemonic.ADDPS);
		map.put("Addsd", Mnemonic.ADDSD);
		map.put("Addss", Mnemonic.ADDSS);
		map.put("Addsubpd", Mnemonic.ADDSUBPD);
		map.put("Addsubps", Mnemonic.ADDSUBPS);
		map.put("Adox", Mnemonic.ADOX);
		map.put("Aesdec", Mnemonic.AESDEC);
		map.put("Aesdeclast", Mnemonic.AESDECLAST);
		map.put("Aesenc", Mnemonic.AESENC);
		map.put("Aesenclast", Mnemonic.AESENCLAST);
		map.put("Aesimc", Mnemonic.AESIMC);
		map.put("Aeskeygenassist", Mnemonic.AESKEYGENASSIST);
		map.put("And", Mnemonic.AND);
		map.put("Andn", Mnemonic.ANDN);
		map.put("Andnpd", Mnemonic.ANDNPD);
		map.put("Andnps", Mnemonic.ANDNPS);
		map.put("Andpd", Mnemonic.ANDPD);
		map.put("Andps", Mnemonic.ANDPS);
		map.put("Arpl", Mnemonic.ARPL);
		map.put("Bextr", Mnemonic.BEXTR);
		map.put("Blcfill", Mnemonic.BLCFILL);
		map.put("Blci", Mnemonic.BLCI);
		map.put("Blcic", Mnemonic.BLCIC);
		map.put("Blcmsk", Mnemonic.BLCMSK);
		map.put("Blcs", Mnemonic.BLCS);
		map.put("Blendpd", Mnemonic.BLENDPD);
		map.put("Blendps", Mnemonic.BLENDPS);
		map.put("Blendvpd", Mnemonic.BLENDVPD);
		map.put("Blendvps", Mnemonic.BLENDVPS);
		map.put("Blsfill", Mnemonic.BLSFILL);
		map.put("Blsi", Mnemonic.BLSI);
		map.put("Blsic", Mnemonic.BLSIC);
		map.put("Blsmsk", Mnemonic.BLSMSK);
		map.put("Blsr", Mnemonic.BLSR);
		map.put("Bndcl", Mnemonic.BNDCL);
		map.put("Bndcn", Mnemonic.BNDCN);
		map.put("Bndcu", Mnemonic.BNDCU);
		map.put("Bndldx", Mnemonic.BNDLDX);
		map.put("Bndmk", Mnemonic.BNDMK);
		map.put("Bndmov", Mnemonic.BNDMOV);
		map.put("Bndstx", Mnemonic.BNDSTX);
		map.put("Bound", Mnemonic.BOUND);
		map.put("Bsf", Mnemonic.BSF);
		map.put("Bsr", Mnemonic.BSR);
		map.put("Bswap", Mnemonic.BSWAP);
		map.put("Bt", Mnemonic.BT);
		map.put("Btc", Mnemonic.BTC);
		map.put("Btr", Mnemonic.BTR);
		map.put("Bts", Mnemonic.BTS);
		map.put("Bzhi", Mnemonic.BZHI);
		map.put("Call", Mnemonic.CALL);
		map.put("Cbw", Mnemonic.CBW);
		map.put("Cdq", Mnemonic.CDQ);
		map.put("Cdqe", Mnemonic.CDQE);
		map.put("Cl1invmb", Mnemonic.CL1INVMB);
		map.put("Clac", Mnemonic.CLAC);
		map.put("Clc", Mnemonic.CLC);
		map.put("Cld", Mnemonic.CLD);
		map.put("Cldemote", Mnemonic.CLDEMOTE);
		map.put("Clflush", Mnemonic.CLFLUSH);
		map.put("Clflushopt", Mnemonic.CLFLUSHOPT);
		map.put("Clgi", Mnemonic.CLGI);
		map.put("Cli", Mnemonic.CLI);
		map.put("Clrssbsy", Mnemonic.CLRSSBSY);
		map.put("Clts", Mnemonic.CLTS);
		map.put("Clwb", Mnemonic.CLWB);
		map.put("Clzero", Mnemonic.CLZERO);
		map.put("Cmc", Mnemonic.CMC);
		map.put("Cmova", Mnemonic.CMOVA);
		map.put("Cmovae", Mnemonic.CMOVAE);
		map.put("Cmovb", Mnemonic.CMOVB);
		map.put("Cmovbe", Mnemonic.CMOVBE);
		map.put("Cmove", Mnemonic.CMOVE);
		map.put("Cmovg", Mnemonic.CMOVG);
		map.put("Cmovge", Mnemonic.CMOVGE);
		map.put("Cmovl", Mnemonic.CMOVL);
		map.put("Cmovle", Mnemonic.CMOVLE);
		map.put("Cmovne", Mnemonic.CMOVNE);
		map.put("Cmovno", Mnemonic.CMOVNO);
		map.put("Cmovnp", Mnemonic.CMOVNP);
		map.put("Cmovns", Mnemonic.CMOVNS);
		map.put("Cmovo", Mnemonic.CMOVO);
		map.put("Cmovp", Mnemonic.CMOVP);
		map.put("Cmovs", Mnemonic.CMOVS);
		map.put("Cmp", Mnemonic.CMP);
		map.put("Cmppd", Mnemonic.CMPPD);
		map.put("Cmpps", Mnemonic.CMPPS);
		map.put("Cmpsb", Mnemonic.CMPSB);
		map.put("Cmpsd", Mnemonic.CMPSD);
		map.put("Cmpsq", Mnemonic.CMPSQ);
		map.put("Cmpss", Mnemonic.CMPSS);
		map.put("Cmpsw", Mnemonic.CMPSW);
		map.put("Cmpxchg", Mnemonic.CMPXCHG);
		map.put("Cmpxchg16b", Mnemonic.CMPXCHG16B);
		map.put("Cmpxchg8b", Mnemonic.CMPXCHG8B);
		map.put("Comisd", Mnemonic.COMISD);
		map.put("Comiss", Mnemonic.COMISS);
		map.put("Cpuid", Mnemonic.CPUID);
		map.put("Cqo", Mnemonic.CQO);
		map.put("Crc32", Mnemonic.CRC32);
		map.put("Cvtdq2pd", Mnemonic.CVTDQ2PD);
		map.put("Cvtdq2ps", Mnemonic.CVTDQ2PS);
		map.put("Cvtpd2dq", Mnemonic.CVTPD2DQ);
		map.put("Cvtpd2pi", Mnemonic.CVTPD2PI);
		map.put("Cvtpd2ps", Mnemonic.CVTPD2PS);
		map.put("Cvtpi2pd", Mnemonic.CVTPI2PD);
		map.put("Cvtpi2ps", Mnemonic.CVTPI2PS);
		map.put("Cvtps2dq", Mnemonic.CVTPS2DQ);
		map.put("Cvtps2pd", Mnemonic.CVTPS2PD);
		map.put("Cvtps2pi", Mnemonic.CVTPS2PI);
		map.put("Cvtsd2si", Mnemonic.CVTSD2SI);
		map.put("Cvtsd2ss", Mnemonic.CVTSD2SS);
		map.put("Cvtsi2sd", Mnemonic.CVTSI2SD);
		map.put("Cvtsi2ss", Mnemonic.CVTSI2SS);
		map.put("Cvtss2sd", Mnemonic.CVTSS2SD);
		map.put("Cvtss2si", Mnemonic.CVTSS2SI);
		map.put("Cvttpd2dq", Mnemonic.CVTTPD2DQ);
		map.put("Cvttpd2pi", Mnemonic.CVTTPD2PI);
		map.put("Cvttps2dq", Mnemonic.CVTTPS2DQ);
		map.put("Cvttps2pi", Mnemonic.CVTTPS2PI);
		map.put("Cvttsd2si", Mnemonic.CVTTSD2SI);
		map.put("Cvttss2si", Mnemonic.CVTTSS2SI);
		map.put("Cwd", Mnemonic.CWD);
		map.put("Cwde", Mnemonic.CWDE);
		map.put("Daa", Mnemonic.DAA);
		map.put("Das", Mnemonic.DAS);
		map.put("Db", Mnemonic.DB);
		map.put("Dd", Mnemonic.DD);
		map.put("Dec", Mnemonic.DEC);
		map.put("Div", Mnemonic.DIV);
		map.put("Divpd", Mnemonic.DIVPD);
		map.put("Divps", Mnemonic.DIVPS);
		map.put("Divsd", Mnemonic.DIVSD);
		map.put("Divss", Mnemonic.DIVSS);
		map.put("Dppd", Mnemonic.DPPD);
		map.put("Dpps", Mnemonic.DPPS);
		map.put("Dq", Mnemonic.DQ);
		map.put("Dw", Mnemonic.DW);
		map.put("Emms", Mnemonic.EMMS);
		map.put("Encls", Mnemonic.ENCLS);
		map.put("Enclu", Mnemonic.ENCLU);
		map.put("Enclv", Mnemonic.ENCLV);
		map.put("Endbr32", Mnemonic.ENDBR32);
		map.put("Endbr64", Mnemonic.ENDBR64);
		map.put("Enqcmd", Mnemonic.ENQCMD);
		map.put("Enqcmds", Mnemonic.ENQCMDS);
		map.put("Enter", Mnemonic.ENTER);
		map.put("Extractps", Mnemonic.EXTRACTPS);
		map.put("Extrq", Mnemonic.EXTRQ);
		map.put("F2xm1", Mnemonic.F2XM1);
		map.put("Fabs", Mnemonic.FABS);
		map.put("Fadd", Mnemonic.FADD);
		map.put("Faddp", Mnemonic.FADDP);
		map.put("Fbld", Mnemonic.FBLD);
		map.put("Fbstp", Mnemonic.FBSTP);
		map.put("Fchs", Mnemonic.FCHS);
		map.put("Fclex", Mnemonic.FCLEX);
		map.put("Fcmovb", Mnemonic.FCMOVB);
		map.put("Fcmovbe", Mnemonic.FCMOVBE);
		map.put("Fcmove", Mnemonic.FCMOVE);
		map.put("Fcmovnb", Mnemonic.FCMOVNB);
		map.put("Fcmovnbe", Mnemonic.FCMOVNBE);
		map.put("Fcmovne", Mnemonic.FCMOVNE);
		map.put("Fcmovnu", Mnemonic.FCMOVNU);
		map.put("Fcmovu", Mnemonic.FCMOVU);
		map.put("Fcom", Mnemonic.FCOM);
		map.put("Fcomi", Mnemonic.FCOMI);
		map.put("Fcomip", Mnemonic.FCOMIP);
		map.put("Fcomp", Mnemonic.FCOMP);
		map.put("Fcompp", Mnemonic.FCOMPP);
		map.put("Fcos", Mnemonic.FCOS);
		map.put("Fdecstp", Mnemonic.FDECSTP);
		map.put("Fdisi", Mnemonic.FDISI);
		map.put("Fdiv", Mnemonic.FDIV);
		map.put("Fdivp", Mnemonic.FDIVP);
		map.put("Fdivr", Mnemonic.FDIVR);
		map.put("Fdivrp", Mnemonic.FDIVRP);
		map.put("Femms", Mnemonic.FEMMS);
		map.put("Feni", Mnemonic.FENI);
		map.put("Ffree", Mnemonic.FFREE);
		map.put("Ffreep", Mnemonic.FFREEP);
		map.put("Fiadd", Mnemonic.FIADD);
		map.put("Ficom", Mnemonic.FICOM);
		map.put("Ficomp", Mnemonic.FICOMP);
		map.put("Fidiv", Mnemonic.FIDIV);
		map.put("Fidivr", Mnemonic.FIDIVR);
		map.put("Fild", Mnemonic.FILD);
		map.put("Fimul", Mnemonic.FIMUL);
		map.put("Fincstp", Mnemonic.FINCSTP);
		map.put("Finit", Mnemonic.FINIT);
		map.put("Fist", Mnemonic.FIST);
		map.put("Fistp", Mnemonic.FISTP);
		map.put("Fisttp", Mnemonic.FISTTP);
		map.put("Fisub", Mnemonic.FISUB);
		map.put("Fisubr", Mnemonic.FISUBR);
		map.put("Fld", Mnemonic.FLD);
		map.put("Fld1", Mnemonic.FLD1);
		map.put("Fldcw", Mnemonic.FLDCW);
		map.put("Fldenv", Mnemonic.FLDENV);
		map.put("Fldl2e", Mnemonic.FLDL2E);
		map.put("Fldl2t", Mnemonic.FLDL2T);
		map.put("Fldlg2", Mnemonic.FLDLG2);
		map.put("Fldln2", Mnemonic.FLDLN2);
		map.put("Fldpi", Mnemonic.FLDPI);
		map.put("Fldz", Mnemonic.FLDZ);
		map.put("Fmul", Mnemonic.FMUL);
		map.put("Fmulp", Mnemonic.FMULP);
		map.put("Fnclex", Mnemonic.FNCLEX);
		map.put("Fndisi", Mnemonic.FNDISI);
		map.put("Fneni", Mnemonic.FNENI);
		map.put("Fninit", Mnemonic.FNINIT);
		map.put("Fnop", Mnemonic.FNOP);
		map.put("Fnsave", Mnemonic.FNSAVE);
		map.put("Fnsetpm", Mnemonic.FNSETPM);
		map.put("Fnstcw", Mnemonic.FNSTCW);
		map.put("Fnstenv", Mnemonic.FNSTENV);
		map.put("Fnstsw", Mnemonic.FNSTSW);
		map.put("Fpatan", Mnemonic.FPATAN);
		map.put("Fprem", Mnemonic.FPREM);
		map.put("Fprem1", Mnemonic.FPREM1);
		map.put("Fptan", Mnemonic.FPTAN);
		map.put("Frndint", Mnemonic.FRNDINT);
		map.put("Frstor", Mnemonic.FRSTOR);
		map.put("Frstpm", Mnemonic.FRSTPM);
		map.put("Fsave", Mnemonic.FSAVE);
		map.put("Fscale", Mnemonic.FSCALE);
		map.put("Fsetpm", Mnemonic.FSETPM);
		map.put("Fsin", Mnemonic.FSIN);
		map.put("Fsincos", Mnemonic.FSINCOS);
		map.put("Fsqrt", Mnemonic.FSQRT);
		map.put("Fst", Mnemonic.FST);
		map.put("Fstcw", Mnemonic.FSTCW);
		map.put("Fstdw", Mnemonic.FSTDW);
		map.put("Fstenv", Mnemonic.FSTENV);
		map.put("Fstp", Mnemonic.FSTP);
		map.put("Fstpnce", Mnemonic.FSTPNCE);
		map.put("Fstsg", Mnemonic.FSTSG);
		map.put("Fstsw", Mnemonic.FSTSW);
		map.put("Fsub", Mnemonic.FSUB);
		map.put("Fsubp", Mnemonic.FSUBP);
		map.put("Fsubr", Mnemonic.FSUBR);
		map.put("Fsubrp", Mnemonic.FSUBRP);
		map.put("Ftst", Mnemonic.FTST);
		map.put("Fucom", Mnemonic.FUCOM);
		map.put("Fucomi", Mnemonic.FUCOMI);
		map.put("Fucomip", Mnemonic.FUCOMIP);
		map.put("Fucomp", Mnemonic.FUCOMP);
		map.put("Fucompp", Mnemonic.FUCOMPP);
		map.put("Fxam", Mnemonic.FXAM);
		map.put("Fxch", Mnemonic.FXCH);
		map.put("Fxrstor", Mnemonic.FXRSTOR);
		map.put("Fxrstor64", Mnemonic.FXRSTOR64);
		map.put("Fxsave", Mnemonic.FXSAVE);
		map.put("Fxsave64", Mnemonic.FXSAVE64);
		map.put("Fxtract", Mnemonic.FXTRACT);
		map.put("Fyl2x", Mnemonic.FYL2X);
		map.put("Fyl2xp1", Mnemonic.FYL2XP1);
		map.put("Getsec", Mnemonic.GETSEC);
		map.put("Gf2p8affineinvqb", Mnemonic.GF2P8AFFINEINVQB);
		map.put("Gf2p8affineqb", Mnemonic.GF2P8AFFINEQB);
		map.put("Gf2p8mulb", Mnemonic.GF2P8MULB);
		map.put("Haddpd", Mnemonic.HADDPD);
		map.put("Haddps", Mnemonic.HADDPS);
		map.put("Hlt", Mnemonic.HLT);
		map.put("Hsubpd", Mnemonic.HSUBPD);
		map.put("Hsubps", Mnemonic.HSUBPS);
		map.put("Ibts", Mnemonic.IBTS);
		map.put("Idiv", Mnemonic.IDIV);
		map.put("Imul", Mnemonic.IMUL);
		map.put("In", Mnemonic.IN);
		map.put("Inc", Mnemonic.INC);
		map.put("Incsspd", Mnemonic.INCSSPD);
		map.put("Incsspq", Mnemonic.INCSSPQ);
		map.put("Insb", Mnemonic.INSB);
		map.put("Insd", Mnemonic.INSD);
		map.put("Insertps", Mnemonic.INSERTPS);
		map.put("Insertq", Mnemonic.INSERTQ);
		map.put("Insw", Mnemonic.INSW);
		map.put("Int", Mnemonic.INT);
		map.put("Int1", Mnemonic.INT1);
		map.put("Into", Mnemonic.INTO);
		map.put("Invd", Mnemonic.INVD);
		map.put("Invept", Mnemonic.INVEPT);
		map.put("Invlpg", Mnemonic.INVLPG);
		map.put("Invlpga", Mnemonic.INVLPGA);
		map.put("Invpcid", Mnemonic.INVPCID);
		map.put("Invvpid", Mnemonic.INVVPID);
		map.put("Iret", Mnemonic.IRET);
		map.put("Ja", Mnemonic.JA);
		map.put("Jae", Mnemonic.JAE);
		map.put("Jb", Mnemonic.JB);
		map.put("Jbe", Mnemonic.JBE);
		map.put("Jcxz", Mnemonic.JCXZ);
		map.put("Je", Mnemonic.JE);
		map.put("Jecxz", Mnemonic.JECXZ);
		map.put("Jg", Mnemonic.JG);
		map.put("Jge", Mnemonic.JGE);
		map.put("Jl", Mnemonic.JL);
		map.put("Jle", Mnemonic.JLE);
		map.put("Jmp", Mnemonic.JMP);
		map.put("Jmpe", Mnemonic.JMPE);
		map.put("Jne", Mnemonic.JNE);
		map.put("Jno", Mnemonic.JNO);
		map.put("Jnp", Mnemonic.JNP);
		map.put("Jns", Mnemonic.JNS);
		map.put("Jo", Mnemonic.JO);
		map.put("Jp", Mnemonic.JP);
		map.put("Jrcxz", Mnemonic.JRCXZ);
		map.put("Js", Mnemonic.JS);
		map.put("Kaddb", Mnemonic.KADDB);
		map.put("Kaddd", Mnemonic.KADDD);
		map.put("Kaddq", Mnemonic.KADDQ);
		map.put("Kaddw", Mnemonic.KADDW);
		map.put("Kandb", Mnemonic.KANDB);
		map.put("Kandd", Mnemonic.KANDD);
		map.put("Kandnb", Mnemonic.KANDNB);
		map.put("Kandnd", Mnemonic.KANDND);
		map.put("Kandnq", Mnemonic.KANDNQ);
		map.put("Kandnw", Mnemonic.KANDNW);
		map.put("Kandq", Mnemonic.KANDQ);
		map.put("Kandw", Mnemonic.KANDW);
		map.put("Kmovb", Mnemonic.KMOVB);
		map.put("Kmovd", Mnemonic.KMOVD);
		map.put("Kmovq", Mnemonic.KMOVQ);
		map.put("Kmovw", Mnemonic.KMOVW);
		map.put("Knotb", Mnemonic.KNOTB);
		map.put("Knotd", Mnemonic.KNOTD);
		map.put("Knotq", Mnemonic.KNOTQ);
		map.put("Knotw", Mnemonic.KNOTW);
		map.put("Korb", Mnemonic.KORB);
		map.put("Kord", Mnemonic.KORD);
		map.put("Korq", Mnemonic.KORQ);
		map.put("Kortestb", Mnemonic.KORTESTB);
		map.put("Kortestd", Mnemonic.KORTESTD);
		map.put("Kortestq", Mnemonic.KORTESTQ);
		map.put("Kortestw", Mnemonic.KORTESTW);
		map.put("Korw", Mnemonic.KORW);
		map.put("Kshiftlb", Mnemonic.KSHIFTLB);
		map.put("Kshiftld", Mnemonic.KSHIFTLD);
		map.put("Kshiftlq", Mnemonic.KSHIFTLQ);
		map.put("Kshiftlw", Mnemonic.KSHIFTLW);
		map.put("Kshiftrb", Mnemonic.KSHIFTRB);
		map.put("Kshiftrd", Mnemonic.KSHIFTRD);
		map.put("Kshiftrq", Mnemonic.KSHIFTRQ);
		map.put("Kshiftrw", Mnemonic.KSHIFTRW);
		map.put("Ktestb", Mnemonic.KTESTB);
		map.put("Ktestd", Mnemonic.KTESTD);
		map.put("Ktestq", Mnemonic.KTESTQ);
		map.put("Ktestw", Mnemonic.KTESTW);
		map.put("Kunpckbw", Mnemonic.KUNPCKBW);
		map.put("Kunpckdq", Mnemonic.KUNPCKDQ);
		map.put("Kunpckwd", Mnemonic.KUNPCKWD);
		map.put("Kxnorb", Mnemonic.KXNORB);
		map.put("Kxnord", Mnemonic.KXNORD);
		map.put("Kxnorq", Mnemonic.KXNORQ);
		map.put("Kxnorw", Mnemonic.KXNORW);
		map.put("Kxorb", Mnemonic.KXORB);
		map.put("Kxord", Mnemonic.KXORD);
		map.put("Kxorq", Mnemonic.KXORQ);
		map.put("Kxorw", Mnemonic.KXORW);
		map.put("Lahf", Mnemonic.LAHF);
		map.put("Lar", Mnemonic.LAR);
		map.put("Lddqu", Mnemonic.LDDQU);
		map.put("Ldmxcsr", Mnemonic.LDMXCSR);
		map.put("Lds", Mnemonic.LDS);
		map.put("Lea", Mnemonic.LEA);
		map.put("Leave", Mnemonic.LEAVE);
		map.put("Les", Mnemonic.LES);
		map.put("Lfence", Mnemonic.LFENCE);
		map.put("Lfs", Mnemonic.LFS);
		map.put("Lgdt", Mnemonic.LGDT);
		map.put("Lgs", Mnemonic.LGS);
		map.put("Lidt", Mnemonic.LIDT);
		map.put("Lldt", Mnemonic.LLDT);
		map.put("Llwpcb", Mnemonic.LLWPCB);
		map.put("Lmsw", Mnemonic.LMSW);
		map.put("Loadall", Mnemonic.LOADALL);
		map.put("Lodsb", Mnemonic.LODSB);
		map.put("Lodsd", Mnemonic.LODSD);
		map.put("Lodsq", Mnemonic.LODSQ);
		map.put("Lodsw", Mnemonic.LODSW);
		map.put("Loop", Mnemonic.LOOP);
		map.put("Loope", Mnemonic.LOOPE);
		map.put("Loopne", Mnemonic.LOOPNE);
		map.put("Lsl", Mnemonic.LSL);
		map.put("Lss", Mnemonic.LSS);
		map.put("Ltr", Mnemonic.LTR);
		map.put("Lwpins", Mnemonic.LWPINS);
		map.put("Lwpval", Mnemonic.LWPVAL);
		map.put("Lzcnt", Mnemonic.LZCNT);
		map.put("Maskmovdqu", Mnemonic.MASKMOVDQU);
		map.put("Maskmovq", Mnemonic.MASKMOVQ);
		map.put("Maxpd", Mnemonic.MAXPD);
		map.put("Maxps", Mnemonic.MAXPS);
		map.put("Maxsd", Mnemonic.MAXSD);
		map.put("Maxss", Mnemonic.MAXSS);
		map.put("Mcommit", Mnemonic.MCOMMIT);
		map.put("Mfence", Mnemonic.MFENCE);
		map.put("Minpd", Mnemonic.MINPD);
		map.put("Minps", Mnemonic.MINPS);
		map.put("Minsd", Mnemonic.MINSD);
		map.put("Minss", Mnemonic.MINSS);
		map.put("Monitor", Mnemonic.MONITOR);
		map.put("Monitorx", Mnemonic.MONITORX);
		map.put("Montmul", Mnemonic.MONTMUL);
		map.put("Mov", Mnemonic.MOV);
		map.put("Movapd", Mnemonic.MOVAPD);
		map.put("Movaps", Mnemonic.MOVAPS);
		map.put("Movbe", Mnemonic.MOVBE);
		map.put("Movd", Mnemonic.MOVD);
		map.put("Movddup", Mnemonic.MOVDDUP);
		map.put("Movdir64b", Mnemonic.MOVDIR64B);
		map.put("Movdiri", Mnemonic.MOVDIRI);
		map.put("Movdq2q", Mnemonic.MOVDQ2Q);
		map.put("Movdqa", Mnemonic.MOVDQA);
		map.put("Movdqu", Mnemonic.MOVDQU);
		map.put("Movhlps", Mnemonic.MOVHLPS);
		map.put("Movhpd", Mnemonic.MOVHPD);
		map.put("Movhps", Mnemonic.MOVHPS);
		map.put("Movlhps", Mnemonic.MOVLHPS);
		map.put("Movlpd", Mnemonic.MOVLPD);
		map.put("Movlps", Mnemonic.MOVLPS);
		map.put("Movmskpd", Mnemonic.MOVMSKPD);
		map.put("Movmskps", Mnemonic.MOVMSKPS);
		map.put("Movntdq", Mnemonic.MOVNTDQ);
		map.put("Movntdqa", Mnemonic.MOVNTDQA);
		map.put("Movnti", Mnemonic.MOVNTI);
		map.put("Movntpd", Mnemonic.MOVNTPD);
		map.put("Movntps", Mnemonic.MOVNTPS);
		map.put("Movntq", Mnemonic.MOVNTQ);
		map.put("Movntsd", Mnemonic.MOVNTSD);
		map.put("Movntss", Mnemonic.MOVNTSS);
		map.put("Movq", Mnemonic.MOVQ);
		map.put("Movq2dq", Mnemonic.MOVQ2DQ);
		map.put("Movsb", Mnemonic.MOVSB);
		map.put("Movsd", Mnemonic.MOVSD);
		map.put("Movshdup", Mnemonic.MOVSHDUP);
		map.put("Movsldup", Mnemonic.MOVSLDUP);
		map.put("Movsq", Mnemonic.MOVSQ);
		map.put("Movss", Mnemonic.MOVSS);
		map.put("Movsw", Mnemonic.MOVSW);
		map.put("Movsx", Mnemonic.MOVSX);
		map.put("Movsxd", Mnemonic.MOVSXD);
		map.put("Movupd", Mnemonic.MOVUPD);
		map.put("Movups", Mnemonic.MOVUPS);
		map.put("Movzx", Mnemonic.MOVZX);
		map.put("Mpsadbw", Mnemonic.MPSADBW);
		map.put("Mul", Mnemonic.MUL);
		map.put("Mulpd", Mnemonic.MULPD);
		map.put("Mulps", Mnemonic.MULPS);
		map.put("Mulsd", Mnemonic.MULSD);
		map.put("Mulss", Mnemonic.MULSS);
		map.put("Mulx", Mnemonic.MULX);
		map.put("Mwait", Mnemonic.MWAIT);
		map.put("Mwaitx", Mnemonic.MWAITX);
		map.put("Neg", Mnemonic.NEG);
		map.put("Nop", Mnemonic.NOP);
		map.put("Not", Mnemonic.NOT);
		map.put("Or", Mnemonic.OR);
		map.put("Orpd", Mnemonic.ORPD);
		map.put("Orps", Mnemonic.ORPS);
		map.put("Out", Mnemonic.OUT);
		map.put("Outsb", Mnemonic.OUTSB);
		map.put("Outsd", Mnemonic.OUTSD);
		map.put("Outsw", Mnemonic.OUTSW);
		map.put("Pabsb", Mnemonic.PABSB);
		map.put("Pabsd", Mnemonic.PABSD);
		map.put("Pabsw", Mnemonic.PABSW);
		map.put("Packssdw", Mnemonic.PACKSSDW);
		map.put("Packsswb", Mnemonic.PACKSSWB);
		map.put("Packusdw", Mnemonic.PACKUSDW);
		map.put("Packuswb", Mnemonic.PACKUSWB);
		map.put("Paddb", Mnemonic.PADDB);
		map.put("Paddd", Mnemonic.PADDD);
		map.put("Paddq", Mnemonic.PADDQ);
		map.put("Paddsb", Mnemonic.PADDSB);
		map.put("Paddsw", Mnemonic.PADDSW);
		map.put("Paddusb", Mnemonic.PADDUSB);
		map.put("Paddusw", Mnemonic.PADDUSW);
		map.put("Paddw", Mnemonic.PADDW);
		map.put("Palignr", Mnemonic.PALIGNR);
		map.put("Pand", Mnemonic.PAND);
		map.put("Pandn", Mnemonic.PANDN);
		map.put("Pause", Mnemonic.PAUSE);
		map.put("Pavgb", Mnemonic.PAVGB);
		map.put("Pavgusb", Mnemonic.PAVGUSB);
		map.put("Pavgw", Mnemonic.PAVGW);
		map.put("Pblendvb", Mnemonic.PBLENDVB);
		map.put("Pblendw", Mnemonic.PBLENDW);
		map.put("Pclmulqdq", Mnemonic.PCLMULQDQ);
		map.put("Pcmpeqb", Mnemonic.PCMPEQB);
	}

	private static void initMap1(HashMap<String, Integer> map) {
		map.put("Pcmpeqd", Mnemonic.PCMPEQD);
		map.put("Pcmpeqq", Mnemonic.PCMPEQQ);
		map.put("Pcmpeqw", Mnemonic.PCMPEQW);
		map.put("Pcmpestri", Mnemonic.PCMPESTRI);
		map.put("Pcmpestri64", Mnemonic.PCMPESTRI64);
		map.put("Pcmpestrm", Mnemonic.PCMPESTRM);
		map.put("Pcmpestrm64", Mnemonic.PCMPESTRM64);
		map.put("Pcmpgtb", Mnemonic.PCMPGTB);
		map.put("Pcmpgtd", Mnemonic.PCMPGTD);
		map.put("Pcmpgtq", Mnemonic.PCMPGTQ);
		map.put("Pcmpgtw", Mnemonic.PCMPGTW);
		map.put("Pcmpistri", Mnemonic.PCMPISTRI);
		map.put("Pcmpistrm", Mnemonic.PCMPISTRM);
		map.put("Pcommit", Mnemonic.PCOMMIT);
		map.put("Pconfig", Mnemonic.PCONFIG);
		map.put("Pdep", Mnemonic.PDEP);
		map.put("Pext", Mnemonic.PEXT);
		map.put("Pextrb", Mnemonic.PEXTRB);
		map.put("Pextrd", Mnemonic.PEXTRD);
		map.put("Pextrq", Mnemonic.PEXTRQ);
		map.put("Pextrw", Mnemonic.PEXTRW);
		map.put("Pf2id", Mnemonic.PF2ID);
		map.put("Pf2iw", Mnemonic.PF2IW);
		map.put("Pfacc", Mnemonic.PFACC);
		map.put("Pfadd", Mnemonic.PFADD);
		map.put("Pfcmpeq", Mnemonic.PFCMPEQ);
		map.put("Pfcmpge", Mnemonic.PFCMPGE);
		map.put("Pfcmpgt", Mnemonic.PFCMPGT);
		map.put("Pfmax", Mnemonic.PFMAX);
		map.put("Pfmin", Mnemonic.PFMIN);
		map.put("Pfmul", Mnemonic.PFMUL);
		map.put("Pfnacc", Mnemonic.PFNACC);
		map.put("Pfpnacc", Mnemonic.PFPNACC);
		map.put("Pfrcp", Mnemonic.PFRCP);
		map.put("Pfrcpit1", Mnemonic.PFRCPIT1);
		map.put("Pfrcpit2", Mnemonic.PFRCPIT2);
		map.put("Pfrcpv", Mnemonic.PFRCPV);
		map.put("Pfrsqit1", Mnemonic.PFRSQIT1);
		map.put("Pfrsqrt", Mnemonic.PFRSQRT);
		map.put("Pfrsqrtv", Mnemonic.PFRSQRTV);
		map.put("Pfsub", Mnemonic.PFSUB);
		map.put("Pfsubr", Mnemonic.PFSUBR);
		map.put("Phaddd", Mnemonic.PHADDD);
		map.put("Phaddsw", Mnemonic.PHADDSW);
		map.put("Phaddw", Mnemonic.PHADDW);
		map.put("Phminposuw", Mnemonic.PHMINPOSUW);
		map.put("Phsubd", Mnemonic.PHSUBD);
		map.put("Phsubsw", Mnemonic.PHSUBSW);
		map.put("Phsubw", Mnemonic.PHSUBW);
		map.put("Pi2fd", Mnemonic.PI2FD);
		map.put("Pi2fw", Mnemonic.PI2FW);
		map.put("Pinsrb", Mnemonic.PINSRB);
		map.put("Pinsrd", Mnemonic.PINSRD);
		map.put("Pinsrq", Mnemonic.PINSRQ);
		map.put("Pinsrw", Mnemonic.PINSRW);
		map.put("Pmaddubsw", Mnemonic.PMADDUBSW);
		map.put("Pmaddwd", Mnemonic.PMADDWD);
		map.put("Pmaxsb", Mnemonic.PMAXSB);
		map.put("Pmaxsd", Mnemonic.PMAXSD);
		map.put("Pmaxsw", Mnemonic.PMAXSW);
		map.put("Pmaxub", Mnemonic.PMAXUB);
		map.put("Pmaxud", Mnemonic.PMAXUD);
		map.put("Pmaxuw", Mnemonic.PMAXUW);
		map.put("Pminsb", Mnemonic.PMINSB);
		map.put("Pminsd", Mnemonic.PMINSD);
		map.put("Pminsw", Mnemonic.PMINSW);
		map.put("Pminub", Mnemonic.PMINUB);
		map.put("Pminud", Mnemonic.PMINUD);
		map.put("Pminuw", Mnemonic.PMINUW);
		map.put("Pmovmskb", Mnemonic.PMOVMSKB);
		map.put("Pmovsxbd", Mnemonic.PMOVSXBD);
		map.put("Pmovsxbq", Mnemonic.PMOVSXBQ);
		map.put("Pmovsxbw", Mnemonic.PMOVSXBW);
		map.put("Pmovsxdq", Mnemonic.PMOVSXDQ);
		map.put("Pmovsxwd", Mnemonic.PMOVSXWD);
		map.put("Pmovsxwq", Mnemonic.PMOVSXWQ);
		map.put("Pmovzxbd", Mnemonic.PMOVZXBD);
		map.put("Pmovzxbq", Mnemonic.PMOVZXBQ);
		map.put("Pmovzxbw", Mnemonic.PMOVZXBW);
		map.put("Pmovzxdq", Mnemonic.PMOVZXDQ);
		map.put("Pmovzxwd", Mnemonic.PMOVZXWD);
		map.put("Pmovzxwq", Mnemonic.PMOVZXWQ);
		map.put("Pmuldq", Mnemonic.PMULDQ);
		map.put("Pmulhrsw", Mnemonic.PMULHRSW);
		map.put("Pmulhrw", Mnemonic.PMULHRW);
		map.put("Pmulhuw", Mnemonic.PMULHUW);
		map.put("Pmulhw", Mnemonic.PMULHW);
		map.put("Pmulld", Mnemonic.PMULLD);
		map.put("Pmullw", Mnemonic.PMULLW);
		map.put("Pmuludq", Mnemonic.PMULUDQ);
		map.put("Pop", Mnemonic.POP);
		map.put("Popa", Mnemonic.POPA);
		map.put("Popcnt", Mnemonic.POPCNT);
		map.put("Popf", Mnemonic.POPF);
		map.put("Por", Mnemonic.POR);
		map.put("Prefetch", Mnemonic.PREFETCH);
		map.put("Prefetchnta", Mnemonic.PREFETCHNTA);
		map.put("Prefetcht0", Mnemonic.PREFETCHT0);
		map.put("Prefetcht1", Mnemonic.PREFETCHT1);
		map.put("Prefetcht2", Mnemonic.PREFETCHT2);
		map.put("Prefetchw", Mnemonic.PREFETCHW);
		map.put("Prefetchwt1", Mnemonic.PREFETCHWT1);
		map.put("Psadbw", Mnemonic.PSADBW);
		map.put("Pshufb", Mnemonic.PSHUFB);
		map.put("Pshufd", Mnemonic.PSHUFD);
		map.put("Pshufhw", Mnemonic.PSHUFHW);
		map.put("Pshuflw", Mnemonic.PSHUFLW);
		map.put("Pshufw", Mnemonic.PSHUFW);
		map.put("Psignb", Mnemonic.PSIGNB);
		map.put("Psignd", Mnemonic.PSIGND);
		map.put("Psignw", Mnemonic.PSIGNW);
		map.put("Pslld", Mnemonic.PSLLD);
		map.put("Pslldq", Mnemonic.PSLLDQ);
		map.put("Psllq", Mnemonic.PSLLQ);
		map.put("Psllw", Mnemonic.PSLLW);
		map.put("Psrad", Mnemonic.PSRAD);
		map.put("Psraw", Mnemonic.PSRAW);
		map.put("Psrld", Mnemonic.PSRLD);
		map.put("Psrldq", Mnemonic.PSRLDQ);
		map.put("Psrlq", Mnemonic.PSRLQ);
		map.put("Psrlw", Mnemonic.PSRLW);
		map.put("Psubb", Mnemonic.PSUBB);
		map.put("Psubd", Mnemonic.PSUBD);
		map.put("Psubq", Mnemonic.PSUBQ);
		map.put("Psubsb", Mnemonic.PSUBSB);
		map.put("Psubsw", Mnemonic.PSUBSW);
		map.put("Psubusb", Mnemonic.PSUBUSB);
		map.put("Psubusw", Mnemonic.PSUBUSW);
		map.put("Psubw", Mnemonic.PSUBW);
		map.put("Pswapd", Mnemonic.PSWAPD);
		map.put("Ptest", Mnemonic.PTEST);
		map.put("Ptwrite", Mnemonic.PTWRITE);
		map.put("Punpckhbw", Mnemonic.PUNPCKHBW);
		map.put("Punpckhdq", Mnemonic.PUNPCKHDQ);
		map.put("Punpckhqdq", Mnemonic.PUNPCKHQDQ);
		map.put("Punpckhwd", Mnemonic.PUNPCKHWD);
		map.put("Punpcklbw", Mnemonic.PUNPCKLBW);
		map.put("Punpckldq", Mnemonic.PUNPCKLDQ);
		map.put("Punpcklqdq", Mnemonic.PUNPCKLQDQ);
		map.put("Punpcklwd", Mnemonic.PUNPCKLWD);
		map.put("Push", Mnemonic.PUSH);
		map.put("Pusha", Mnemonic.PUSHA);
		map.put("Pushf", Mnemonic.PUSHF);
		map.put("Pxor", Mnemonic.PXOR);
		map.put("Rcl", Mnemonic.RCL);
		map.put("Rcpps", Mnemonic.RCPPS);
		map.put("Rcpss", Mnemonic.RCPSS);
		map.put("Rcr", Mnemonic.RCR);
		map.put("Rdfsbase", Mnemonic.RDFSBASE);
		map.put("Rdgsbase", Mnemonic.RDGSBASE);
		map.put("Rdmsr", Mnemonic.RDMSR);
		map.put("Rdpid", Mnemonic.RDPID);
		map.put("Rdpkru", Mnemonic.RDPKRU);
		map.put("Rdpmc", Mnemonic.RDPMC);
		map.put("Rdpru", Mnemonic.RDPRU);
		map.put("Rdrand", Mnemonic.RDRAND);
		map.put("Rdseed", Mnemonic.RDSEED);
		map.put("Rdsspd", Mnemonic.RDSSPD);
		map.put("Rdsspq", Mnemonic.RDSSPQ);
		map.put("Rdtsc", Mnemonic.RDTSC);
		map.put("Rdtscp", Mnemonic.RDTSCP);
		map.put("Reservednop", Mnemonic.RESERVEDNOP);
		map.put("Ret", Mnemonic.RET);
		map.put("Retf", Mnemonic.RETF);
		map.put("Rol", Mnemonic.ROL);
		map.put("Ror", Mnemonic.ROR);
		map.put("Rorx", Mnemonic.RORX);
		map.put("Roundpd", Mnemonic.ROUNDPD);
		map.put("Roundps", Mnemonic.ROUNDPS);
		map.put("Roundsd", Mnemonic.ROUNDSD);
		map.put("Roundss", Mnemonic.ROUNDSS);
		map.put("Rsm", Mnemonic.RSM);
		map.put("Rsqrtps", Mnemonic.RSQRTPS);
		map.put("Rsqrtss", Mnemonic.RSQRTSS);
		map.put("Rstorssp", Mnemonic.RSTORSSP);
		map.put("Sahf", Mnemonic.SAHF);
		map.put("Sal", Mnemonic.SAL);
		map.put("Salc", Mnemonic.SALC);
		map.put("Sar", Mnemonic.SAR);
		map.put("Sarx", Mnemonic.SARX);
		map.put("Saveprevssp", Mnemonic.SAVEPREVSSP);
		map.put("Sbb", Mnemonic.SBB);
		map.put("Scasb", Mnemonic.SCASB);
		map.put("Scasd", Mnemonic.SCASD);
		map.put("Scasq", Mnemonic.SCASQ);
		map.put("Scasw", Mnemonic.SCASW);
		map.put("Seta", Mnemonic.SETA);
		map.put("Setae", Mnemonic.SETAE);
		map.put("Setb", Mnemonic.SETB);
		map.put("Setbe", Mnemonic.SETBE);
		map.put("Sete", Mnemonic.SETE);
		map.put("Setg", Mnemonic.SETG);
		map.put("Setge", Mnemonic.SETGE);
		map.put("Setl", Mnemonic.SETL);
		map.put("Setle", Mnemonic.SETLE);
		map.put("Setne", Mnemonic.SETNE);
		map.put("Setno", Mnemonic.SETNO);
		map.put("Setnp", Mnemonic.SETNP);
		map.put("Setns", Mnemonic.SETNS);
		map.put("Seto", Mnemonic.SETO);
		map.put("Setp", Mnemonic.SETP);
		map.put("Sets", Mnemonic.SETS);
		map.put("Setssbsy", Mnemonic.SETSSBSY);
		map.put("Sfence", Mnemonic.SFENCE);
		map.put("Sgdt", Mnemonic.SGDT);
		map.put("Sha1msg1", Mnemonic.SHA1MSG1);
		map.put("Sha1msg2", Mnemonic.SHA1MSG2);
		map.put("Sha1nexte", Mnemonic.SHA1NEXTE);
		map.put("Sha1rnds4", Mnemonic.SHA1RNDS4);
		map.put("Sha256msg1", Mnemonic.SHA256MSG1);
		map.put("Sha256msg2", Mnemonic.SHA256MSG2);
		map.put("Sha256rnds2", Mnemonic.SHA256RNDS2);
		map.put("Shl", Mnemonic.SHL);
		map.put("Shld", Mnemonic.SHLD);
		map.put("Shlx", Mnemonic.SHLX);
		map.put("Shr", Mnemonic.SHR);
		map.put("Shrd", Mnemonic.SHRD);
		map.put("Shrx", Mnemonic.SHRX);
		map.put("Shufpd", Mnemonic.SHUFPD);
		map.put("Shufps", Mnemonic.SHUFPS);
		map.put("Sidt", Mnemonic.SIDT);
		map.put("Skinit", Mnemonic.SKINIT);
		map.put("Sldt", Mnemonic.SLDT);
		map.put("Slwpcb", Mnemonic.SLWPCB);
		map.put("Smsw", Mnemonic.SMSW);
		map.put("Sqrtpd", Mnemonic.SQRTPD);
		map.put("Sqrtps", Mnemonic.SQRTPS);
		map.put("Sqrtsd", Mnemonic.SQRTSD);
		map.put("Sqrtss", Mnemonic.SQRTSS);
		map.put("Stac", Mnemonic.STAC);
		map.put("Stc", Mnemonic.STC);
		map.put("Std", Mnemonic.STD);
		map.put("Stgi", Mnemonic.STGI);
		map.put("Sti", Mnemonic.STI);
		map.put("Stmxcsr", Mnemonic.STMXCSR);
		map.put("Stosb", Mnemonic.STOSB);
		map.put("Stosd", Mnemonic.STOSD);
		map.put("Stosq", Mnemonic.STOSQ);
		map.put("Stosw", Mnemonic.STOSW);
		map.put("Str", Mnemonic.STR);
		map.put("Sub", Mnemonic.SUB);
		map.put("Subpd", Mnemonic.SUBPD);
		map.put("Subps", Mnemonic.SUBPS);
		map.put("Subsd", Mnemonic.SUBSD);
		map.put("Subss", Mnemonic.SUBSS);
		map.put("Swapgs", Mnemonic.SWAPGS);
		map.put("Syscall", Mnemonic.SYSCALL);
		map.put("Sysenter", Mnemonic.SYSENTER);
		map.put("Sysexit", Mnemonic.SYSEXIT);
		map.put("Sysret", Mnemonic.SYSRET);
		map.put("T1mskc", Mnemonic.T1MSKC);
		map.put("Test", Mnemonic.TEST);
		map.put("Tpause", Mnemonic.TPAUSE);
		map.put("Tzcnt", Mnemonic.TZCNT);
		map.put("Tzmsk", Mnemonic.TZMSK);
		map.put("Ucomisd", Mnemonic.UCOMISD);
		map.put("Ucomiss", Mnemonic.UCOMISS);
		map.put("Ud0", Mnemonic.UD0);
		map.put("Ud1", Mnemonic.UD1);
		map.put("Ud2", Mnemonic.UD2);
		map.put("Umonitor", Mnemonic.UMONITOR);
		map.put("Umov", Mnemonic.UMOV);
		map.put("Umwait", Mnemonic.UMWAIT);
		map.put("Unpckhpd", Mnemonic.UNPCKHPD);
		map.put("Unpckhps", Mnemonic.UNPCKHPS);
		map.put("Unpcklpd", Mnemonic.UNPCKLPD);
		map.put("Unpcklps", Mnemonic.UNPCKLPS);
		map.put("V4fmaddps", Mnemonic.V4FMADDPS);
		map.put("V4fmaddss", Mnemonic.V4FMADDSS);
		map.put("V4fnmaddps", Mnemonic.V4FNMADDPS);
		map.put("V4fnmaddss", Mnemonic.V4FNMADDSS);
		map.put("Vaddpd", Mnemonic.VADDPD);
		map.put("Vaddps", Mnemonic.VADDPS);
		map.put("Vaddsd", Mnemonic.VADDSD);
		map.put("Vaddss", Mnemonic.VADDSS);
		map.put("Vaddsubpd", Mnemonic.VADDSUBPD);
		map.put("Vaddsubps", Mnemonic.VADDSUBPS);
		map.put("Vaesdec", Mnemonic.VAESDEC);
		map.put("Vaesdeclast", Mnemonic.VAESDECLAST);
		map.put("Vaesenc", Mnemonic.VAESENC);
		map.put("Vaesenclast", Mnemonic.VAESENCLAST);
		map.put("Vaesimc", Mnemonic.VAESIMC);
		map.put("Vaeskeygenassist", Mnemonic.VAESKEYGENASSIST);
		map.put("Valignd", Mnemonic.VALIGND);
		map.put("Valignq", Mnemonic.VALIGNQ);
		map.put("Vandnpd", Mnemonic.VANDNPD);
		map.put("Vandnps", Mnemonic.VANDNPS);
		map.put("Vandpd", Mnemonic.VANDPD);
		map.put("Vandps", Mnemonic.VANDPS);
		map.put("Vblendmpd", Mnemonic.VBLENDMPD);
		map.put("Vblendmps", Mnemonic.VBLENDMPS);
		map.put("Vblendpd", Mnemonic.VBLENDPD);
		map.put("Vblendps", Mnemonic.VBLENDPS);
		map.put("Vblendvpd", Mnemonic.VBLENDVPD);
		map.put("Vblendvps", Mnemonic.VBLENDVPS);
		map.put("Vbroadcastf128", Mnemonic.VBROADCASTF128);
		map.put("Vbroadcastf32x2", Mnemonic.VBROADCASTF32X2);
		map.put("Vbroadcastf32x4", Mnemonic.VBROADCASTF32X4);
		map.put("Vbroadcastf32x8", Mnemonic.VBROADCASTF32X8);
		map.put("Vbroadcastf64x2", Mnemonic.VBROADCASTF64X2);
		map.put("Vbroadcastf64x4", Mnemonic.VBROADCASTF64X4);
		map.put("Vbroadcasti128", Mnemonic.VBROADCASTI128);
		map.put("Vbroadcasti32x2", Mnemonic.VBROADCASTI32X2);
		map.put("Vbroadcasti32x4", Mnemonic.VBROADCASTI32X4);
		map.put("Vbroadcasti32x8", Mnemonic.VBROADCASTI32X8);
		map.put("Vbroadcasti64x2", Mnemonic.VBROADCASTI64X2);
		map.put("Vbroadcasti64x4", Mnemonic.VBROADCASTI64X4);
		map.put("Vbroadcastsd", Mnemonic.VBROADCASTSD);
		map.put("Vbroadcastss", Mnemonic.VBROADCASTSS);
		map.put("Vcmppd", Mnemonic.VCMPPD);
		map.put("Vcmpps", Mnemonic.VCMPPS);
		map.put("Vcmpsd", Mnemonic.VCMPSD);
		map.put("Vcmpss", Mnemonic.VCMPSS);
		map.put("Vcomisd", Mnemonic.VCOMISD);
		map.put("Vcomiss", Mnemonic.VCOMISS);
		map.put("Vcompresspd", Mnemonic.VCOMPRESSPD);
		map.put("Vcompressps", Mnemonic.VCOMPRESSPS);
		map.put("Vcvtdq2pd", Mnemonic.VCVTDQ2PD);
		map.put("Vcvtdq2ps", Mnemonic.VCVTDQ2PS);
		map.put("Vcvtne2ps2bf16", Mnemonic.VCVTNE2PS2BF16);
		map.put("Vcvtneps2bf16", Mnemonic.VCVTNEPS2BF16);
		map.put("Vcvtpd2dq", Mnemonic.VCVTPD2DQ);
		map.put("Vcvtpd2ps", Mnemonic.VCVTPD2PS);
		map.put("Vcvtpd2qq", Mnemonic.VCVTPD2QQ);
		map.put("Vcvtpd2udq", Mnemonic.VCVTPD2UDQ);
		map.put("Vcvtpd2uqq", Mnemonic.VCVTPD2UQQ);
		map.put("Vcvtph2ps", Mnemonic.VCVTPH2PS);
		map.put("Vcvtps2dq", Mnemonic.VCVTPS2DQ);
		map.put("Vcvtps2pd", Mnemonic.VCVTPS2PD);
		map.put("Vcvtps2ph", Mnemonic.VCVTPS2PH);
		map.put("Vcvtps2qq", Mnemonic.VCVTPS2QQ);
		map.put("Vcvtps2udq", Mnemonic.VCVTPS2UDQ);
		map.put("Vcvtps2uqq", Mnemonic.VCVTPS2UQQ);
		map.put("Vcvtqq2pd", Mnemonic.VCVTQQ2PD);
		map.put("Vcvtqq2ps", Mnemonic.VCVTQQ2PS);
		map.put("Vcvtsd2si", Mnemonic.VCVTSD2SI);
		map.put("Vcvtsd2ss", Mnemonic.VCVTSD2SS);
		map.put("Vcvtsd2usi", Mnemonic.VCVTSD2USI);
		map.put("Vcvtsi2sd", Mnemonic.VCVTSI2SD);
		map.put("Vcvtsi2ss", Mnemonic.VCVTSI2SS);
		map.put("Vcvtss2sd", Mnemonic.VCVTSS2SD);
		map.put("Vcvtss2si", Mnemonic.VCVTSS2SI);
		map.put("Vcvtss2usi", Mnemonic.VCVTSS2USI);
		map.put("Vcvttpd2dq", Mnemonic.VCVTTPD2DQ);
		map.put("Vcvttpd2qq", Mnemonic.VCVTTPD2QQ);
		map.put("Vcvttpd2udq", Mnemonic.VCVTTPD2UDQ);
		map.put("Vcvttpd2uqq", Mnemonic.VCVTTPD2UQQ);
		map.put("Vcvttps2dq", Mnemonic.VCVTTPS2DQ);
		map.put("Vcvttps2qq", Mnemonic.VCVTTPS2QQ);
		map.put("Vcvttps2udq", Mnemonic.VCVTTPS2UDQ);
		map.put("Vcvttps2uqq", Mnemonic.VCVTTPS2UQQ);
		map.put("Vcvttsd2si", Mnemonic.VCVTTSD2SI);
		map.put("Vcvttsd2usi", Mnemonic.VCVTTSD2USI);
		map.put("Vcvttss2si", Mnemonic.VCVTTSS2SI);
		map.put("Vcvttss2usi", Mnemonic.VCVTTSS2USI);
		map.put("Vcvtudq2pd", Mnemonic.VCVTUDQ2PD);
		map.put("Vcvtudq2ps", Mnemonic.VCVTUDQ2PS);
		map.put("Vcvtuqq2pd", Mnemonic.VCVTUQQ2PD);
		map.put("Vcvtuqq2ps", Mnemonic.VCVTUQQ2PS);
		map.put("Vcvtusi2sd", Mnemonic.VCVTUSI2SD);
		map.put("Vcvtusi2ss", Mnemonic.VCVTUSI2SS);
		map.put("Vdbpsadbw", Mnemonic.VDBPSADBW);
		map.put("Vdivpd", Mnemonic.VDIVPD);
		map.put("Vdivps", Mnemonic.VDIVPS);
		map.put("Vdivsd", Mnemonic.VDIVSD);
		map.put("Vdivss", Mnemonic.VDIVSS);
		map.put("Vdpbf16ps", Mnemonic.VDPBF16PS);
		map.put("Vdppd", Mnemonic.VDPPD);
		map.put("Vdpps", Mnemonic.VDPPS);
		map.put("Verr", Mnemonic.VERR);
		map.put("Verw", Mnemonic.VERW);
		map.put("Vexp2pd", Mnemonic.VEXP2PD);
		map.put("Vexp2ps", Mnemonic.VEXP2PS);
		map.put("Vexpandpd", Mnemonic.VEXPANDPD);
		map.put("Vexpandps", Mnemonic.VEXPANDPS);
		map.put("Vextractf128", Mnemonic.VEXTRACTF128);
		map.put("Vextractf32x4", Mnemonic.VEXTRACTF32X4);
		map.put("Vextractf32x8", Mnemonic.VEXTRACTF32X8);
		map.put("Vextractf64x2", Mnemonic.VEXTRACTF64X2);
		map.put("Vextractf64x4", Mnemonic.VEXTRACTF64X4);
		map.put("Vextracti128", Mnemonic.VEXTRACTI128);
		map.put("Vextracti32x4", Mnemonic.VEXTRACTI32X4);
		map.put("Vextracti32x8", Mnemonic.VEXTRACTI32X8);
		map.put("Vextracti64x2", Mnemonic.VEXTRACTI64X2);
		map.put("Vextracti64x4", Mnemonic.VEXTRACTI64X4);
		map.put("Vextractps", Mnemonic.VEXTRACTPS);
		map.put("Vfixupimmpd", Mnemonic.VFIXUPIMMPD);
		map.put("Vfixupimmps", Mnemonic.VFIXUPIMMPS);
		map.put("Vfixupimmsd", Mnemonic.VFIXUPIMMSD);
		map.put("Vfixupimmss", Mnemonic.VFIXUPIMMSS);
		map.put("Vfmadd132pd", Mnemonic.VFMADD132PD);
		map.put("Vfmadd132ps", Mnemonic.VFMADD132PS);
		map.put("Vfmadd132sd", Mnemonic.VFMADD132SD);
		map.put("Vfmadd132ss", Mnemonic.VFMADD132SS);
		map.put("Vfmadd213pd", Mnemonic.VFMADD213PD);
		map.put("Vfmadd213ps", Mnemonic.VFMADD213PS);
		map.put("Vfmadd213sd", Mnemonic.VFMADD213SD);
		map.put("Vfmadd213ss", Mnemonic.VFMADD213SS);
		map.put("Vfmadd231pd", Mnemonic.VFMADD231PD);
		map.put("Vfmadd231ps", Mnemonic.VFMADD231PS);
		map.put("Vfmadd231sd", Mnemonic.VFMADD231SD);
		map.put("Vfmadd231ss", Mnemonic.VFMADD231SS);
		map.put("Vfmaddpd", Mnemonic.VFMADDPD);
		map.put("Vfmaddps", Mnemonic.VFMADDPS);
		map.put("Vfmaddsd", Mnemonic.VFMADDSD);
		map.put("Vfmaddss", Mnemonic.VFMADDSS);
		map.put("Vfmaddsub132pd", Mnemonic.VFMADDSUB132PD);
		map.put("Vfmaddsub132ps", Mnemonic.VFMADDSUB132PS);
		map.put("Vfmaddsub213pd", Mnemonic.VFMADDSUB213PD);
		map.put("Vfmaddsub213ps", Mnemonic.VFMADDSUB213PS);
		map.put("Vfmaddsub231pd", Mnemonic.VFMADDSUB231PD);
		map.put("Vfmaddsub231ps", Mnemonic.VFMADDSUB231PS);
		map.put("Vfmaddsubpd", Mnemonic.VFMADDSUBPD);
		map.put("Vfmaddsubps", Mnemonic.VFMADDSUBPS);
		map.put("Vfmsub132pd", Mnemonic.VFMSUB132PD);
		map.put("Vfmsub132ps", Mnemonic.VFMSUB132PS);
		map.put("Vfmsub132sd", Mnemonic.VFMSUB132SD);
		map.put("Vfmsub132ss", Mnemonic.VFMSUB132SS);
		map.put("Vfmsub213pd", Mnemonic.VFMSUB213PD);
		map.put("Vfmsub213ps", Mnemonic.VFMSUB213PS);
		map.put("Vfmsub213sd", Mnemonic.VFMSUB213SD);
		map.put("Vfmsub213ss", Mnemonic.VFMSUB213SS);
		map.put("Vfmsub231pd", Mnemonic.VFMSUB231PD);
		map.put("Vfmsub231ps", Mnemonic.VFMSUB231PS);
		map.put("Vfmsub231sd", Mnemonic.VFMSUB231SD);
		map.put("Vfmsub231ss", Mnemonic.VFMSUB231SS);
		map.put("Vfmsubadd132pd", Mnemonic.VFMSUBADD132PD);
		map.put("Vfmsubadd132ps", Mnemonic.VFMSUBADD132PS);
		map.put("Vfmsubadd213pd", Mnemonic.VFMSUBADD213PD);
		map.put("Vfmsubadd213ps", Mnemonic.VFMSUBADD213PS);
		map.put("Vfmsubadd231pd", Mnemonic.VFMSUBADD231PD);
		map.put("Vfmsubadd231ps", Mnemonic.VFMSUBADD231PS);
		map.put("Vfmsubaddpd", Mnemonic.VFMSUBADDPD);
		map.put("Vfmsubaddps", Mnemonic.VFMSUBADDPS);
		map.put("Vfmsubpd", Mnemonic.VFMSUBPD);
		map.put("Vfmsubps", Mnemonic.VFMSUBPS);
		map.put("Vfmsubsd", Mnemonic.VFMSUBSD);
		map.put("Vfmsubss", Mnemonic.VFMSUBSS);
		map.put("Vfnmadd132pd", Mnemonic.VFNMADD132PD);
		map.put("Vfnmadd132ps", Mnemonic.VFNMADD132PS);
		map.put("Vfnmadd132sd", Mnemonic.VFNMADD132SD);
		map.put("Vfnmadd132ss", Mnemonic.VFNMADD132SS);
		map.put("Vfnmadd213pd", Mnemonic.VFNMADD213PD);
		map.put("Vfnmadd213ps", Mnemonic.VFNMADD213PS);
		map.put("Vfnmadd213sd", Mnemonic.VFNMADD213SD);
		map.put("Vfnmadd213ss", Mnemonic.VFNMADD213SS);
		map.put("Vfnmadd231pd", Mnemonic.VFNMADD231PD);
		map.put("Vfnmadd231ps", Mnemonic.VFNMADD231PS);
		map.put("Vfnmadd231sd", Mnemonic.VFNMADD231SD);
		map.put("Vfnmadd231ss", Mnemonic.VFNMADD231SS);
		map.put("Vfnmaddpd", Mnemonic.VFNMADDPD);
		map.put("Vfnmaddps", Mnemonic.VFNMADDPS);
		map.put("Vfnmaddsd", Mnemonic.VFNMADDSD);
		map.put("Vfnmaddss", Mnemonic.VFNMADDSS);
		map.put("Vfnmsub132pd", Mnemonic.VFNMSUB132PD);
		map.put("Vfnmsub132ps", Mnemonic.VFNMSUB132PS);
		map.put("Vfnmsub132sd", Mnemonic.VFNMSUB132SD);
		map.put("Vfnmsub132ss", Mnemonic.VFNMSUB132SS);
		map.put("Vfnmsub213pd", Mnemonic.VFNMSUB213PD);
		map.put("Vfnmsub213ps", Mnemonic.VFNMSUB213PS);
		map.put("Vfnmsub213sd", Mnemonic.VFNMSUB213SD);
		map.put("Vfnmsub213ss", Mnemonic.VFNMSUB213SS);
		map.put("Vfnmsub231pd", Mnemonic.VFNMSUB231PD);
		map.put("Vfnmsub231ps", Mnemonic.VFNMSUB231PS);
		map.put("Vfnmsub231sd", Mnemonic.VFNMSUB231SD);
		map.put("Vfnmsub231ss", Mnemonic.VFNMSUB231SS);
		map.put("Vfnmsubpd", Mnemonic.VFNMSUBPD);
		map.put("Vfnmsubps", Mnemonic.VFNMSUBPS);
		map.put("Vfnmsubsd", Mnemonic.VFNMSUBSD);
		map.put("Vfnmsubss", Mnemonic.VFNMSUBSS);
		map.put("Vfpclasspd", Mnemonic.VFPCLASSPD);
		map.put("Vfpclassps", Mnemonic.VFPCLASSPS);
		map.put("Vfpclasssd", Mnemonic.VFPCLASSSD);
		map.put("Vfpclassss", Mnemonic.VFPCLASSSS);
		map.put("Vfrczpd", Mnemonic.VFRCZPD);
		map.put("Vfrczps", Mnemonic.VFRCZPS);
		map.put("Vfrczsd", Mnemonic.VFRCZSD);
		map.put("Vfrczss", Mnemonic.VFRCZSS);
		map.put("Vgatherdpd", Mnemonic.VGATHERDPD);
		map.put("Vgatherdps", Mnemonic.VGATHERDPS);
		map.put("Vgatherpf0dpd", Mnemonic.VGATHERPF0DPD);
		map.put("Vgatherpf0dps", Mnemonic.VGATHERPF0DPS);
		map.put("Vgatherpf0qpd", Mnemonic.VGATHERPF0QPD);
		map.put("Vgatherpf0qps", Mnemonic.VGATHERPF0QPS);
		map.put("Vgatherpf1dpd", Mnemonic.VGATHERPF1DPD);
		map.put("Vgatherpf1dps", Mnemonic.VGATHERPF1DPS);
		map.put("Vgatherpf1qpd", Mnemonic.VGATHERPF1QPD);
		map.put("Vgatherpf1qps", Mnemonic.VGATHERPF1QPS);
		map.put("Vgatherqpd", Mnemonic.VGATHERQPD);
		map.put("Vgatherqps", Mnemonic.VGATHERQPS);
		map.put("Vgetexppd", Mnemonic.VGETEXPPD);
		map.put("Vgetexpps", Mnemonic.VGETEXPPS);
		map.put("Vgetexpsd", Mnemonic.VGETEXPSD);
		map.put("Vgetexpss", Mnemonic.VGETEXPSS);
		map.put("Vgetmantpd", Mnemonic.VGETMANTPD);
		map.put("Vgetmantps", Mnemonic.VGETMANTPS);
		map.put("Vgetmantsd", Mnemonic.VGETMANTSD);
		map.put("Vgetmantss", Mnemonic.VGETMANTSS);
		map.put("Vgf2p8affineinvqb", Mnemonic.VGF2P8AFFINEINVQB);
		map.put("Vgf2p8affineqb", Mnemonic.VGF2P8AFFINEQB);
	}

	private static void initMap2(HashMap<String, Integer> map) {
		map.put("Vgf2p8mulb", Mnemonic.VGF2P8MULB);
		map.put("Vhaddpd", Mnemonic.VHADDPD);
		map.put("Vhaddps", Mnemonic.VHADDPS);
		map.put("Vhsubpd", Mnemonic.VHSUBPD);
		map.put("Vhsubps", Mnemonic.VHSUBPS);
		map.put("Vinsertf128", Mnemonic.VINSERTF128);
		map.put("Vinsertf32x4", Mnemonic.VINSERTF32X4);
		map.put("Vinsertf32x8", Mnemonic.VINSERTF32X8);
		map.put("Vinsertf64x2", Mnemonic.VINSERTF64X2);
		map.put("Vinsertf64x4", Mnemonic.VINSERTF64X4);
		map.put("Vinserti128", Mnemonic.VINSERTI128);
		map.put("Vinserti32x4", Mnemonic.VINSERTI32X4);
		map.put("Vinserti32x8", Mnemonic.VINSERTI32X8);
		map.put("Vinserti64x2", Mnemonic.VINSERTI64X2);
		map.put("Vinserti64x4", Mnemonic.VINSERTI64X4);
		map.put("Vinsertps", Mnemonic.VINSERTPS);
		map.put("Vlddqu", Mnemonic.VLDDQU);
		map.put("Vldmxcsr", Mnemonic.VLDMXCSR);
		map.put("Vmaskmovdqu", Mnemonic.VMASKMOVDQU);
		map.put("Vmaskmovpd", Mnemonic.VMASKMOVPD);
		map.put("Vmaskmovps", Mnemonic.VMASKMOVPS);
		map.put("Vmaxpd", Mnemonic.VMAXPD);
		map.put("Vmaxps", Mnemonic.VMAXPS);
		map.put("Vmaxsd", Mnemonic.VMAXSD);
		map.put("Vmaxss", Mnemonic.VMAXSS);
		map.put("Vmcall", Mnemonic.VMCALL);
		map.put("Vmclear", Mnemonic.VMCLEAR);
		map.put("Vmfunc", Mnemonic.VMFUNC);
		map.put("Vminpd", Mnemonic.VMINPD);
		map.put("Vminps", Mnemonic.VMINPS);
		map.put("Vminsd", Mnemonic.VMINSD);
		map.put("Vminss", Mnemonic.VMINSS);
		map.put("Vmlaunch", Mnemonic.VMLAUNCH);
		map.put("Vmload", Mnemonic.VMLOAD);
		map.put("Vmmcall", Mnemonic.VMMCALL);
		map.put("Vmovapd", Mnemonic.VMOVAPD);
		map.put("Vmovaps", Mnemonic.VMOVAPS);
		map.put("Vmovd", Mnemonic.VMOVD);
		map.put("Vmovddup", Mnemonic.VMOVDDUP);
		map.put("Vmovdqa", Mnemonic.VMOVDQA);
		map.put("Vmovdqa32", Mnemonic.VMOVDQA32);
		map.put("Vmovdqa64", Mnemonic.VMOVDQA64);
		map.put("Vmovdqu", Mnemonic.VMOVDQU);
		map.put("Vmovdqu16", Mnemonic.VMOVDQU16);
		map.put("Vmovdqu32", Mnemonic.VMOVDQU32);
		map.put("Vmovdqu64", Mnemonic.VMOVDQU64);
		map.put("Vmovdqu8", Mnemonic.VMOVDQU8);
		map.put("Vmovhlps", Mnemonic.VMOVHLPS);
		map.put("Vmovhpd", Mnemonic.VMOVHPD);
		map.put("Vmovhps", Mnemonic.VMOVHPS);
		map.put("Vmovlhps", Mnemonic.VMOVLHPS);
		map.put("Vmovlpd", Mnemonic.VMOVLPD);
		map.put("Vmovlps", Mnemonic.VMOVLPS);
		map.put("Vmovmskpd", Mnemonic.VMOVMSKPD);
		map.put("Vmovmskps", Mnemonic.VMOVMSKPS);
		map.put("Vmovntdq", Mnemonic.VMOVNTDQ);
		map.put("Vmovntdqa", Mnemonic.VMOVNTDQA);
		map.put("Vmovntpd", Mnemonic.VMOVNTPD);
		map.put("Vmovntps", Mnemonic.VMOVNTPS);
		map.put("Vmovq", Mnemonic.VMOVQ);
		map.put("Vmovsd", Mnemonic.VMOVSD);
		map.put("Vmovshdup", Mnemonic.VMOVSHDUP);
		map.put("Vmovsldup", Mnemonic.VMOVSLDUP);
		map.put("Vmovss", Mnemonic.VMOVSS);
		map.put("Vmovupd", Mnemonic.VMOVUPD);
		map.put("Vmovups", Mnemonic.VMOVUPS);
		map.put("Vmpsadbw", Mnemonic.VMPSADBW);
		map.put("Vmptrld", Mnemonic.VMPTRLD);
		map.put("Vmptrst", Mnemonic.VMPTRST);
		map.put("Vmread", Mnemonic.VMREAD);
		map.put("Vmresume", Mnemonic.VMRESUME);
		map.put("Vmrun", Mnemonic.VMRUN);
		map.put("Vmsave", Mnemonic.VMSAVE);
		map.put("Vmulpd", Mnemonic.VMULPD);
		map.put("Vmulps", Mnemonic.VMULPS);
		map.put("Vmulsd", Mnemonic.VMULSD);
		map.put("Vmulss", Mnemonic.VMULSS);
		map.put("Vmwrite", Mnemonic.VMWRITE);
		map.put("Vmxoff", Mnemonic.VMXOFF);
		map.put("Vmxon", Mnemonic.VMXON);
		map.put("Vorpd", Mnemonic.VORPD);
		map.put("Vorps", Mnemonic.VORPS);
		map.put("Vp2intersectd", Mnemonic.VP2INTERSECTD);
		map.put("Vp2intersectq", Mnemonic.VP2INTERSECTQ);
		map.put("Vp4dpwssd", Mnemonic.VP4DPWSSD);
		map.put("Vp4dpwssds", Mnemonic.VP4DPWSSDS);
		map.put("Vpabsb", Mnemonic.VPABSB);
		map.put("Vpabsd", Mnemonic.VPABSD);
		map.put("Vpabsq", Mnemonic.VPABSQ);
		map.put("Vpabsw", Mnemonic.VPABSW);
		map.put("Vpackssdw", Mnemonic.VPACKSSDW);
		map.put("Vpacksswb", Mnemonic.VPACKSSWB);
		map.put("Vpackusdw", Mnemonic.VPACKUSDW);
		map.put("Vpackuswb", Mnemonic.VPACKUSWB);
		map.put("Vpaddb", Mnemonic.VPADDB);
		map.put("Vpaddd", Mnemonic.VPADDD);
		map.put("Vpaddq", Mnemonic.VPADDQ);
		map.put("Vpaddsb", Mnemonic.VPADDSB);
		map.put("Vpaddsw", Mnemonic.VPADDSW);
		map.put("Vpaddusb", Mnemonic.VPADDUSB);
		map.put("Vpaddusw", Mnemonic.VPADDUSW);
		map.put("Vpaddw", Mnemonic.VPADDW);
		map.put("Vpalignr", Mnemonic.VPALIGNR);
		map.put("Vpand", Mnemonic.VPAND);
		map.put("Vpandd", Mnemonic.VPANDD);
		map.put("Vpandn", Mnemonic.VPANDN);
		map.put("Vpandnd", Mnemonic.VPANDND);
		map.put("Vpandnq", Mnemonic.VPANDNQ);
		map.put("Vpandq", Mnemonic.VPANDQ);
		map.put("Vpavgb", Mnemonic.VPAVGB);
		map.put("Vpavgw", Mnemonic.VPAVGW);
		map.put("Vpblendd", Mnemonic.VPBLENDD);
		map.put("Vpblendmb", Mnemonic.VPBLENDMB);
		map.put("Vpblendmd", Mnemonic.VPBLENDMD);
		map.put("Vpblendmq", Mnemonic.VPBLENDMQ);
		map.put("Vpblendmw", Mnemonic.VPBLENDMW);
		map.put("Vpblendvb", Mnemonic.VPBLENDVB);
		map.put("Vpblendw", Mnemonic.VPBLENDW);
		map.put("Vpbroadcastb", Mnemonic.VPBROADCASTB);
		map.put("Vpbroadcastd", Mnemonic.VPBROADCASTD);
		map.put("Vpbroadcastmb2q", Mnemonic.VPBROADCASTMB2Q);
		map.put("Vpbroadcastmw2d", Mnemonic.VPBROADCASTMW2D);
		map.put("Vpbroadcastq", Mnemonic.VPBROADCASTQ);
		map.put("Vpbroadcastw", Mnemonic.VPBROADCASTW);
		map.put("Vpclmulqdq", Mnemonic.VPCLMULQDQ);
		map.put("Vpcmov", Mnemonic.VPCMOV);
		map.put("Vpcmpb", Mnemonic.VPCMPB);
		map.put("Vpcmpd", Mnemonic.VPCMPD);
		map.put("Vpcmpeqb", Mnemonic.VPCMPEQB);
		map.put("Vpcmpeqd", Mnemonic.VPCMPEQD);
		map.put("Vpcmpeqq", Mnemonic.VPCMPEQQ);
		map.put("Vpcmpeqw", Mnemonic.VPCMPEQW);
		map.put("Vpcmpestri", Mnemonic.VPCMPESTRI);
		map.put("Vpcmpestri64", Mnemonic.VPCMPESTRI64);
		map.put("Vpcmpestrm", Mnemonic.VPCMPESTRM);
		map.put("Vpcmpestrm64", Mnemonic.VPCMPESTRM64);
		map.put("Vpcmpgtb", Mnemonic.VPCMPGTB);
		map.put("Vpcmpgtd", Mnemonic.VPCMPGTD);
		map.put("Vpcmpgtq", Mnemonic.VPCMPGTQ);
		map.put("Vpcmpgtw", Mnemonic.VPCMPGTW);
		map.put("Vpcmpistri", Mnemonic.VPCMPISTRI);
		map.put("Vpcmpistrm", Mnemonic.VPCMPISTRM);
		map.put("Vpcmpq", Mnemonic.VPCMPQ);
		map.put("Vpcmpub", Mnemonic.VPCMPUB);
		map.put("Vpcmpud", Mnemonic.VPCMPUD);
		map.put("Vpcmpuq", Mnemonic.VPCMPUQ);
		map.put("Vpcmpuw", Mnemonic.VPCMPUW);
		map.put("Vpcmpw", Mnemonic.VPCMPW);
		map.put("Vpcomb", Mnemonic.VPCOMB);
		map.put("Vpcomd", Mnemonic.VPCOMD);
		map.put("Vpcompressb", Mnemonic.VPCOMPRESSB);
		map.put("Vpcompressd", Mnemonic.VPCOMPRESSD);
		map.put("Vpcompressq", Mnemonic.VPCOMPRESSQ);
		map.put("Vpcompressw", Mnemonic.VPCOMPRESSW);
		map.put("Vpcomq", Mnemonic.VPCOMQ);
		map.put("Vpcomub", Mnemonic.VPCOMUB);
		map.put("Vpcomud", Mnemonic.VPCOMUD);
		map.put("Vpcomuq", Mnemonic.VPCOMUQ);
		map.put("Vpcomuw", Mnemonic.VPCOMUW);
		map.put("Vpcomw", Mnemonic.VPCOMW);
		map.put("Vpconflictd", Mnemonic.VPCONFLICTD);
		map.put("Vpconflictq", Mnemonic.VPCONFLICTQ);
		map.put("Vpdpbusd", Mnemonic.VPDPBUSD);
		map.put("Vpdpbusds", Mnemonic.VPDPBUSDS);
		map.put("Vpdpwssd", Mnemonic.VPDPWSSD);
		map.put("Vpdpwssds", Mnemonic.VPDPWSSDS);
		map.put("Vperm2f128", Mnemonic.VPERM2F128);
		map.put("Vperm2i128", Mnemonic.VPERM2I128);
		map.put("Vpermb", Mnemonic.VPERMB);
		map.put("Vpermd", Mnemonic.VPERMD);
		map.put("Vpermi2b", Mnemonic.VPERMI2B);
		map.put("Vpermi2d", Mnemonic.VPERMI2D);
		map.put("Vpermi2pd", Mnemonic.VPERMI2PD);
		map.put("Vpermi2ps", Mnemonic.VPERMI2PS);
		map.put("Vpermi2q", Mnemonic.VPERMI2Q);
		map.put("Vpermi2w", Mnemonic.VPERMI2W);
		map.put("Vpermil2pd", Mnemonic.VPERMIL2PD);
		map.put("Vpermil2ps", Mnemonic.VPERMIL2PS);
		map.put("Vpermilpd", Mnemonic.VPERMILPD);
		map.put("Vpermilps", Mnemonic.VPERMILPS);
		map.put("Vpermpd", Mnemonic.VPERMPD);
		map.put("Vpermps", Mnemonic.VPERMPS);
		map.put("Vpermq", Mnemonic.VPERMQ);
		map.put("Vpermt2b", Mnemonic.VPERMT2B);
		map.put("Vpermt2d", Mnemonic.VPERMT2D);
		map.put("Vpermt2pd", Mnemonic.VPERMT2PD);
		map.put("Vpermt2ps", Mnemonic.VPERMT2PS);
		map.put("Vpermt2q", Mnemonic.VPERMT2Q);
		map.put("Vpermt2w", Mnemonic.VPERMT2W);
		map.put("Vpermw", Mnemonic.VPERMW);
		map.put("Vpexpandb", Mnemonic.VPEXPANDB);
		map.put("Vpexpandd", Mnemonic.VPEXPANDD);
		map.put("Vpexpandq", Mnemonic.VPEXPANDQ);
		map.put("Vpexpandw", Mnemonic.VPEXPANDW);
		map.put("Vpextrb", Mnemonic.VPEXTRB);
		map.put("Vpextrd", Mnemonic.VPEXTRD);
		map.put("Vpextrq", Mnemonic.VPEXTRQ);
		map.put("Vpextrw", Mnemonic.VPEXTRW);
		map.put("Vpgatherdd", Mnemonic.VPGATHERDD);
		map.put("Vpgatherdq", Mnemonic.VPGATHERDQ);
		map.put("Vpgatherqd", Mnemonic.VPGATHERQD);
		map.put("Vpgatherqq", Mnemonic.VPGATHERQQ);
		map.put("Vphaddbd", Mnemonic.VPHADDBD);
		map.put("Vphaddbq", Mnemonic.VPHADDBQ);
		map.put("Vphaddbw", Mnemonic.VPHADDBW);
		map.put("Vphaddd", Mnemonic.VPHADDD);
		map.put("Vphadddq", Mnemonic.VPHADDDQ);
		map.put("Vphaddsw", Mnemonic.VPHADDSW);
		map.put("Vphaddubd", Mnemonic.VPHADDUBD);
		map.put("Vphaddubq", Mnemonic.VPHADDUBQ);
		map.put("Vphaddubw", Mnemonic.VPHADDUBW);
		map.put("Vphaddudq", Mnemonic.VPHADDUDQ);
		map.put("Vphadduwd", Mnemonic.VPHADDUWD);
		map.put("Vphadduwq", Mnemonic.VPHADDUWQ);
		map.put("Vphaddw", Mnemonic.VPHADDW);
		map.put("Vphaddwd", Mnemonic.VPHADDWD);
		map.put("Vphaddwq", Mnemonic.VPHADDWQ);
		map.put("Vphminposuw", Mnemonic.VPHMINPOSUW);
		map.put("Vphsubbw", Mnemonic.VPHSUBBW);
		map.put("Vphsubd", Mnemonic.VPHSUBD);
		map.put("Vphsubdq", Mnemonic.VPHSUBDQ);
		map.put("Vphsubsw", Mnemonic.VPHSUBSW);
		map.put("Vphsubw", Mnemonic.VPHSUBW);
		map.put("Vphsubwd", Mnemonic.VPHSUBWD);
		map.put("Vpinsrb", Mnemonic.VPINSRB);
		map.put("Vpinsrd", Mnemonic.VPINSRD);
		map.put("Vpinsrq", Mnemonic.VPINSRQ);
		map.put("Vpinsrw", Mnemonic.VPINSRW);
		map.put("Vplzcntd", Mnemonic.VPLZCNTD);
		map.put("Vplzcntq", Mnemonic.VPLZCNTQ);
		map.put("Vpmacsdd", Mnemonic.VPMACSDD);
		map.put("Vpmacsdqh", Mnemonic.VPMACSDQH);
		map.put("Vpmacsdql", Mnemonic.VPMACSDQL);
		map.put("Vpmacssdd", Mnemonic.VPMACSSDD);
		map.put("Vpmacssdqh", Mnemonic.VPMACSSDQH);
		map.put("Vpmacssdql", Mnemonic.VPMACSSDQL);
		map.put("Vpmacsswd", Mnemonic.VPMACSSWD);
		map.put("Vpmacssww", Mnemonic.VPMACSSWW);
		map.put("Vpmacswd", Mnemonic.VPMACSWD);
		map.put("Vpmacsww", Mnemonic.VPMACSWW);
		map.put("Vpmadcsswd", Mnemonic.VPMADCSSWD);
		map.put("Vpmadcswd", Mnemonic.VPMADCSWD);
		map.put("Vpmadd52huq", Mnemonic.VPMADD52HUQ);
		map.put("Vpmadd52luq", Mnemonic.VPMADD52LUQ);
		map.put("Vpmaddubsw", Mnemonic.VPMADDUBSW);
		map.put("Vpmaddwd", Mnemonic.VPMADDWD);
		map.put("Vpmaskmovd", Mnemonic.VPMASKMOVD);
		map.put("Vpmaskmovq", Mnemonic.VPMASKMOVQ);
		map.put("Vpmaxsb", Mnemonic.VPMAXSB);
		map.put("Vpmaxsd", Mnemonic.VPMAXSD);
		map.put("Vpmaxsq", Mnemonic.VPMAXSQ);
		map.put("Vpmaxsw", Mnemonic.VPMAXSW);
		map.put("Vpmaxub", Mnemonic.VPMAXUB);
		map.put("Vpmaxud", Mnemonic.VPMAXUD);
		map.put("Vpmaxuq", Mnemonic.VPMAXUQ);
		map.put("Vpmaxuw", Mnemonic.VPMAXUW);
		map.put("Vpminsb", Mnemonic.VPMINSB);
		map.put("Vpminsd", Mnemonic.VPMINSD);
		map.put("Vpminsq", Mnemonic.VPMINSQ);
		map.put("Vpminsw", Mnemonic.VPMINSW);
		map.put("Vpminub", Mnemonic.VPMINUB);
		map.put("Vpminud", Mnemonic.VPMINUD);
		map.put("Vpminuq", Mnemonic.VPMINUQ);
		map.put("Vpminuw", Mnemonic.VPMINUW);
		map.put("Vpmovb2m", Mnemonic.VPMOVB2M);
		map.put("Vpmovd2m", Mnemonic.VPMOVD2M);
		map.put("Vpmovdb", Mnemonic.VPMOVDB);
		map.put("Vpmovdw", Mnemonic.VPMOVDW);
		map.put("Vpmovm2b", Mnemonic.VPMOVM2B);
		map.put("Vpmovm2d", Mnemonic.VPMOVM2D);
		map.put("Vpmovm2q", Mnemonic.VPMOVM2Q);
		map.put("Vpmovm2w", Mnemonic.VPMOVM2W);
		map.put("Vpmovmskb", Mnemonic.VPMOVMSKB);
		map.put("Vpmovq2m", Mnemonic.VPMOVQ2M);
		map.put("Vpmovqb", Mnemonic.VPMOVQB);
		map.put("Vpmovqd", Mnemonic.VPMOVQD);
		map.put("Vpmovqw", Mnemonic.VPMOVQW);
		map.put("Vpmovsdb", Mnemonic.VPMOVSDB);
		map.put("Vpmovsdw", Mnemonic.VPMOVSDW);
		map.put("Vpmovsqb", Mnemonic.VPMOVSQB);
		map.put("Vpmovsqd", Mnemonic.VPMOVSQD);
		map.put("Vpmovsqw", Mnemonic.VPMOVSQW);
		map.put("Vpmovswb", Mnemonic.VPMOVSWB);
		map.put("Vpmovsxbd", Mnemonic.VPMOVSXBD);
		map.put("Vpmovsxbq", Mnemonic.VPMOVSXBQ);
		map.put("Vpmovsxbw", Mnemonic.VPMOVSXBW);
		map.put("Vpmovsxdq", Mnemonic.VPMOVSXDQ);
		map.put("Vpmovsxwd", Mnemonic.VPMOVSXWD);
		map.put("Vpmovsxwq", Mnemonic.VPMOVSXWQ);
		map.put("Vpmovusdb", Mnemonic.VPMOVUSDB);
		map.put("Vpmovusdw", Mnemonic.VPMOVUSDW);
		map.put("Vpmovusqb", Mnemonic.VPMOVUSQB);
		map.put("Vpmovusqd", Mnemonic.VPMOVUSQD);
		map.put("Vpmovusqw", Mnemonic.VPMOVUSQW);
		map.put("Vpmovuswb", Mnemonic.VPMOVUSWB);
		map.put("Vpmovw2m", Mnemonic.VPMOVW2M);
		map.put("Vpmovwb", Mnemonic.VPMOVWB);
		map.put("Vpmovzxbd", Mnemonic.VPMOVZXBD);
		map.put("Vpmovzxbq", Mnemonic.VPMOVZXBQ);
		map.put("Vpmovzxbw", Mnemonic.VPMOVZXBW);
		map.put("Vpmovzxdq", Mnemonic.VPMOVZXDQ);
		map.put("Vpmovzxwd", Mnemonic.VPMOVZXWD);
		map.put("Vpmovzxwq", Mnemonic.VPMOVZXWQ);
		map.put("Vpmuldq", Mnemonic.VPMULDQ);
		map.put("Vpmulhrsw", Mnemonic.VPMULHRSW);
		map.put("Vpmulhuw", Mnemonic.VPMULHUW);
		map.put("Vpmulhw", Mnemonic.VPMULHW);
		map.put("Vpmulld", Mnemonic.VPMULLD);
		map.put("Vpmullq", Mnemonic.VPMULLQ);
		map.put("Vpmullw", Mnemonic.VPMULLW);
		map.put("Vpmultishiftqb", Mnemonic.VPMULTISHIFTQB);
		map.put("Vpmuludq", Mnemonic.VPMULUDQ);
		map.put("Vpopcntb", Mnemonic.VPOPCNTB);
		map.put("Vpopcntd", Mnemonic.VPOPCNTD);
		map.put("Vpopcntq", Mnemonic.VPOPCNTQ);
		map.put("Vpopcntw", Mnemonic.VPOPCNTW);
		map.put("Vpor", Mnemonic.VPOR);
		map.put("Vpord", Mnemonic.VPORD);
		map.put("Vporq", Mnemonic.VPORQ);
		map.put("Vpperm", Mnemonic.VPPERM);
		map.put("Vprold", Mnemonic.VPROLD);
		map.put("Vprolq", Mnemonic.VPROLQ);
		map.put("Vprolvd", Mnemonic.VPROLVD);
		map.put("Vprolvq", Mnemonic.VPROLVQ);
		map.put("Vprord", Mnemonic.VPRORD);
		map.put("Vprorq", Mnemonic.VPRORQ);
		map.put("Vprorvd", Mnemonic.VPRORVD);
		map.put("Vprorvq", Mnemonic.VPRORVQ);
		map.put("Vprotb", Mnemonic.VPROTB);
		map.put("Vprotd", Mnemonic.VPROTD);
		map.put("Vprotq", Mnemonic.VPROTQ);
		map.put("Vprotw", Mnemonic.VPROTW);
		map.put("Vpsadbw", Mnemonic.VPSADBW);
		map.put("Vpscatterdd", Mnemonic.VPSCATTERDD);
		map.put("Vpscatterdq", Mnemonic.VPSCATTERDQ);
		map.put("Vpscatterqd", Mnemonic.VPSCATTERQD);
		map.put("Vpscatterqq", Mnemonic.VPSCATTERQQ);
		map.put("Vpshab", Mnemonic.VPSHAB);
		map.put("Vpshad", Mnemonic.VPSHAD);
		map.put("Vpshaq", Mnemonic.VPSHAQ);
		map.put("Vpshaw", Mnemonic.VPSHAW);
		map.put("Vpshlb", Mnemonic.VPSHLB);
		map.put("Vpshld", Mnemonic.VPSHLD);
		map.put("Vpshldd", Mnemonic.VPSHLDD);
		map.put("Vpshldq", Mnemonic.VPSHLDQ);
		map.put("Vpshldvd", Mnemonic.VPSHLDVD);
		map.put("Vpshldvq", Mnemonic.VPSHLDVQ);
		map.put("Vpshldvw", Mnemonic.VPSHLDVW);
		map.put("Vpshldw", Mnemonic.VPSHLDW);
		map.put("Vpshlq", Mnemonic.VPSHLQ);
		map.put("Vpshlw", Mnemonic.VPSHLW);
		map.put("Vpshrdd", Mnemonic.VPSHRDD);
		map.put("Vpshrdq", Mnemonic.VPSHRDQ);
		map.put("Vpshrdvd", Mnemonic.VPSHRDVD);
		map.put("Vpshrdvq", Mnemonic.VPSHRDVQ);
		map.put("Vpshrdvw", Mnemonic.VPSHRDVW);
		map.put("Vpshrdw", Mnemonic.VPSHRDW);
		map.put("Vpshufb", Mnemonic.VPSHUFB);
		map.put("Vpshufbitqmb", Mnemonic.VPSHUFBITQMB);
		map.put("Vpshufd", Mnemonic.VPSHUFD);
		map.put("Vpshufhw", Mnemonic.VPSHUFHW);
		map.put("Vpshuflw", Mnemonic.VPSHUFLW);
		map.put("Vpsignb", Mnemonic.VPSIGNB);
		map.put("Vpsignd", Mnemonic.VPSIGND);
		map.put("Vpsignw", Mnemonic.VPSIGNW);
		map.put("Vpslld", Mnemonic.VPSLLD);
		map.put("Vpslldq", Mnemonic.VPSLLDQ);
		map.put("Vpsllq", Mnemonic.VPSLLQ);
		map.put("Vpsllvd", Mnemonic.VPSLLVD);
		map.put("Vpsllvq", Mnemonic.VPSLLVQ);
		map.put("Vpsllvw", Mnemonic.VPSLLVW);
		map.put("Vpsllw", Mnemonic.VPSLLW);
		map.put("Vpsrad", Mnemonic.VPSRAD);
		map.put("Vpsraq", Mnemonic.VPSRAQ);
		map.put("Vpsravd", Mnemonic.VPSRAVD);
		map.put("Vpsravq", Mnemonic.VPSRAVQ);
		map.put("Vpsravw", Mnemonic.VPSRAVW);
		map.put("Vpsraw", Mnemonic.VPSRAW);
		map.put("Vpsrld", Mnemonic.VPSRLD);
		map.put("Vpsrldq", Mnemonic.VPSRLDQ);
		map.put("Vpsrlq", Mnemonic.VPSRLQ);
		map.put("Vpsrlvd", Mnemonic.VPSRLVD);
		map.put("Vpsrlvq", Mnemonic.VPSRLVQ);
		map.put("Vpsrlvw", Mnemonic.VPSRLVW);
		map.put("Vpsrlw", Mnemonic.VPSRLW);
		map.put("Vpsubb", Mnemonic.VPSUBB);
		map.put("Vpsubd", Mnemonic.VPSUBD);
		map.put("Vpsubq", Mnemonic.VPSUBQ);
		map.put("Vpsubsb", Mnemonic.VPSUBSB);
		map.put("Vpsubsw", Mnemonic.VPSUBSW);
		map.put("Vpsubusb", Mnemonic.VPSUBUSB);
		map.put("Vpsubusw", Mnemonic.VPSUBUSW);
		map.put("Vpsubw", Mnemonic.VPSUBW);
		map.put("Vpternlogd", Mnemonic.VPTERNLOGD);
		map.put("Vpternlogq", Mnemonic.VPTERNLOGQ);
		map.put("Vptest", Mnemonic.VPTEST);
		map.put("Vptestmb", Mnemonic.VPTESTMB);
		map.put("Vptestmd", Mnemonic.VPTESTMD);
		map.put("Vptestmq", Mnemonic.VPTESTMQ);
		map.put("Vptestmw", Mnemonic.VPTESTMW);
		map.put("Vptestnmb", Mnemonic.VPTESTNMB);
		map.put("Vptestnmd", Mnemonic.VPTESTNMD);
		map.put("Vptestnmq", Mnemonic.VPTESTNMQ);
		map.put("Vptestnmw", Mnemonic.VPTESTNMW);
		map.put("Vpunpckhbw", Mnemonic.VPUNPCKHBW);
		map.put("Vpunpckhdq", Mnemonic.VPUNPCKHDQ);
		map.put("Vpunpckhqdq", Mnemonic.VPUNPCKHQDQ);
		map.put("Vpunpckhwd", Mnemonic.VPUNPCKHWD);
		map.put("Vpunpcklbw", Mnemonic.VPUNPCKLBW);
		map.put("Vpunpckldq", Mnemonic.VPUNPCKLDQ);
		map.put("Vpunpcklqdq", Mnemonic.VPUNPCKLQDQ);
		map.put("Vpunpcklwd", Mnemonic.VPUNPCKLWD);
		map.put("Vpxor", Mnemonic.VPXOR);
		map.put("Vpxord", Mnemonic.VPXORD);
		map.put("Vpxorq", Mnemonic.VPXORQ);
		map.put("Vrangepd", Mnemonic.VRANGEPD);
		map.put("Vrangeps", Mnemonic.VRANGEPS);
		map.put("Vrangesd", Mnemonic.VRANGESD);
		map.put("Vrangess", Mnemonic.VRANGESS);
		map.put("Vrcp14pd", Mnemonic.VRCP14PD);
		map.put("Vrcp14ps", Mnemonic.VRCP14PS);
		map.put("Vrcp14sd", Mnemonic.VRCP14SD);
		map.put("Vrcp14ss", Mnemonic.VRCP14SS);
		map.put("Vrcp28pd", Mnemonic.VRCP28PD);
		map.put("Vrcp28ps", Mnemonic.VRCP28PS);
		map.put("Vrcp28sd", Mnemonic.VRCP28SD);
		map.put("Vrcp28ss", Mnemonic.VRCP28SS);
		map.put("Vrcpps", Mnemonic.VRCPPS);
		map.put("Vrcpss", Mnemonic.VRCPSS);
		map.put("Vreducepd", Mnemonic.VREDUCEPD);
		map.put("Vreduceps", Mnemonic.VREDUCEPS);
		map.put("Vreducesd", Mnemonic.VREDUCESD);
		map.put("Vreducess", Mnemonic.VREDUCESS);
		map.put("Vrndscalepd", Mnemonic.VRNDSCALEPD);
		map.put("Vrndscaleps", Mnemonic.VRNDSCALEPS);
		map.put("Vrndscalesd", Mnemonic.VRNDSCALESD);
		map.put("Vrndscaless", Mnemonic.VRNDSCALESS);
		map.put("Vroundpd", Mnemonic.VROUNDPD);
		map.put("Vroundps", Mnemonic.VROUNDPS);
		map.put("Vroundsd", Mnemonic.VROUNDSD);
		map.put("Vroundss", Mnemonic.VROUNDSS);
		map.put("Vrsqrt14pd", Mnemonic.VRSQRT14PD);
		map.put("Vrsqrt14ps", Mnemonic.VRSQRT14PS);
		map.put("Vrsqrt14sd", Mnemonic.VRSQRT14SD);
		map.put("Vrsqrt14ss", Mnemonic.VRSQRT14SS);
		map.put("Vrsqrt28pd", Mnemonic.VRSQRT28PD);
		map.put("Vrsqrt28ps", Mnemonic.VRSQRT28PS);
		map.put("Vrsqrt28sd", Mnemonic.VRSQRT28SD);
		map.put("Vrsqrt28ss", Mnemonic.VRSQRT28SS);
		map.put("Vrsqrtps", Mnemonic.VRSQRTPS);
		map.put("Vrsqrtss", Mnemonic.VRSQRTSS);
		map.put("Vscalefpd", Mnemonic.VSCALEFPD);
		map.put("Vscalefps", Mnemonic.VSCALEFPS);
		map.put("Vscalefsd", Mnemonic.VSCALEFSD);
		map.put("Vscalefss", Mnemonic.VSCALEFSS);
		map.put("Vscatterdpd", Mnemonic.VSCATTERDPD);
		map.put("Vscatterdps", Mnemonic.VSCATTERDPS);
		map.put("Vscatterpf0dpd", Mnemonic.VSCATTERPF0DPD);
		map.put("Vscatterpf0dps", Mnemonic.VSCATTERPF0DPS);
		map.put("Vscatterpf0qpd", Mnemonic.VSCATTERPF0QPD);
		map.put("Vscatterpf0qps", Mnemonic.VSCATTERPF0QPS);
		map.put("Vscatterpf1dpd", Mnemonic.VSCATTERPF1DPD);
		map.put("Vscatterpf1dps", Mnemonic.VSCATTERPF1DPS);
		map.put("Vscatterpf1qpd", Mnemonic.VSCATTERPF1QPD);
		map.put("Vscatterpf1qps", Mnemonic.VSCATTERPF1QPS);
		map.put("Vscatterqpd", Mnemonic.VSCATTERQPD);
		map.put("Vscatterqps", Mnemonic.VSCATTERQPS);
		map.put("Vshuff32x4", Mnemonic.VSHUFF32X4);
		map.put("Vshuff64x2", Mnemonic.VSHUFF64X2);
		map.put("Vshufi32x4", Mnemonic.VSHUFI32X4);
		map.put("Vshufi64x2", Mnemonic.VSHUFI64X2);
		map.put("Vshufpd", Mnemonic.VSHUFPD);
		map.put("Vshufps", Mnemonic.VSHUFPS);
		map.put("Vsqrtpd", Mnemonic.VSQRTPD);
		map.put("Vsqrtps", Mnemonic.VSQRTPS);
		map.put("Vsqrtsd", Mnemonic.VSQRTSD);
		map.put("Vsqrtss", Mnemonic.VSQRTSS);
		map.put("Vstmxcsr", Mnemonic.VSTMXCSR);
		map.put("Vsubpd", Mnemonic.VSUBPD);
		map.put("Vsubps", Mnemonic.VSUBPS);
		map.put("Vsubsd", Mnemonic.VSUBSD);
		map.put("Vsubss", Mnemonic.VSUBSS);
		map.put("Vtestpd", Mnemonic.VTESTPD);
		map.put("Vtestps", Mnemonic.VTESTPS);
		map.put("Vucomisd", Mnemonic.VUCOMISD);
		map.put("Vucomiss", Mnemonic.VUCOMISS);
		map.put("Vunpckhpd", Mnemonic.VUNPCKHPD);
		map.put("Vunpckhps", Mnemonic.VUNPCKHPS);
		map.put("Vunpcklpd", Mnemonic.VUNPCKLPD);
		map.put("Vunpcklps", Mnemonic.VUNPCKLPS);
		map.put("Vxorpd", Mnemonic.VXORPD);
		map.put("Vxorps", Mnemonic.VXORPS);
		map.put("Vzeroall", Mnemonic.VZEROALL);
		map.put("Vzeroupper", Mnemonic.VZEROUPPER);
		map.put("Wait", Mnemonic.WAIT);
		map.put("Wbinvd", Mnemonic.WBINVD);
		map.put("Wbnoinvd", Mnemonic.WBNOINVD);
		map.put("Wrfsbase", Mnemonic.WRFSBASE);
		map.put("Wrgsbase", Mnemonic.WRGSBASE);
		map.put("Wrmsr", Mnemonic.WRMSR);
	}

	private static void initMap3(HashMap<String, Integer> map) {
		map.put("Wrpkru", Mnemonic.WRPKRU);
		map.put("Wrssd", Mnemonic.WRSSD);
		map.put("Wrssq", Mnemonic.WRSSQ);
		map.put("Wrussd", Mnemonic.WRUSSD);
		map.put("Wrussq", Mnemonic.WRUSSQ);
		map.put("Xabort", Mnemonic.XABORT);
		map.put("Xadd", Mnemonic.XADD);
		map.put("Xbegin", Mnemonic.XBEGIN);
		map.put("Xbts", Mnemonic.XBTS);
		map.put("Xchg", Mnemonic.XCHG);
		map.put("Xcryptcbc", Mnemonic.XCRYPTCBC);
		map.put("Xcryptcfb", Mnemonic.XCRYPTCFB);
		map.put("Xcryptctr", Mnemonic.XCRYPTCTR);
		map.put("Xcryptecb", Mnemonic.XCRYPTECB);
		map.put("Xcryptofb", Mnemonic.XCRYPTOFB);
		map.put("Xend", Mnemonic.XEND);
		map.put("Xgetbv", Mnemonic.XGETBV);
		map.put("Xlatb", Mnemonic.XLATB);
		map.put("Xor", Mnemonic.XOR);
		map.put("Xorpd", Mnemonic.XORPD);
		map.put("Xorps", Mnemonic.XORPS);
		map.put("Xrstor", Mnemonic.XRSTOR);
		map.put("Xrstor64", Mnemonic.XRSTOR64);
		map.put("Xrstors", Mnemonic.XRSTORS);
		map.put("Xrstors64", Mnemonic.XRSTORS64);
		map.put("Xsave", Mnemonic.XSAVE);
		map.put("Xsave64", Mnemonic.XSAVE64);
		map.put("Xsavec", Mnemonic.XSAVEC);
		map.put("Xsavec64", Mnemonic.XSAVEC64);
		map.put("Xsaveopt", Mnemonic.XSAVEOPT);
		map.put("Xsaveopt64", Mnemonic.XSAVEOPT64);
		map.put("Xsaves", Mnemonic.XSAVES);
		map.put("Xsaves64", Mnemonic.XSAVES64);
		map.put("Xsetbv", Mnemonic.XSETBV);
		map.put("Xsha1", Mnemonic.XSHA1);
		map.put("Xsha256", Mnemonic.XSHA256);
		map.put("Xstore", Mnemonic.XSTORE);
		map.put("Xtest", Mnemonic.XTEST);
		map.put("Rmpadjust", Mnemonic.RMPADJUST);
		map.put("Rmpupdate", Mnemonic.RMPUPDATE);
		map.put("Psmash", Mnemonic.PSMASH);
		map.put("Pvalidate", Mnemonic.PVALIDATE);
		map.put("Serialize", Mnemonic.SERIALIZE);
		map.put("Xsusldtrk", Mnemonic.XSUSLDTRK);
		map.put("Xresldtrk", Mnemonic.XRESLDTRK);
		map.put("Invlpgb", Mnemonic.INVLPGB);
		map.put("Tlbsync", Mnemonic.TLBSYNC);
		map.put("Vmgexit", Mnemonic.VMGEXIT);
		map.put("Getsecq", Mnemonic.GETSECQ);
		map.put("Sysexitq", Mnemonic.SYSEXITQ);
		map.put("Ldtilecfg", Mnemonic.LDTILECFG);
		map.put("Tilerelease", Mnemonic.TILERELEASE);
		map.put("Sttilecfg", Mnemonic.STTILECFG);
		map.put("Tilezero", Mnemonic.TILEZERO);
		map.put("Tileloaddt1", Mnemonic.TILELOADDT1);
		map.put("Tilestored", Mnemonic.TILESTORED);
		map.put("Tileloadd", Mnemonic.TILELOADD);
		map.put("Tdpbf16ps", Mnemonic.TDPBF16PS);
		map.put("Tdpbuud", Mnemonic.TDPBUUD);
		map.put("Tdpbusd", Mnemonic.TDPBUSD);
		map.put("Tdpbsud", Mnemonic.TDPBSUD);
		map.put("Tdpbssd", Mnemonic.TDPBSSD);
		map.put("Sysretq", Mnemonic.SYSRETQ);
		map.put("Fnstdw", Mnemonic.FNSTDW);
		map.put("Fnstsg", Mnemonic.FNSTSG);
		map.put("Rdshr", Mnemonic.RDSHR);
		map.put("Wrshr", Mnemonic.WRSHR);
		map.put("Smint", Mnemonic.SMINT);
		map.put("Dmint", Mnemonic.DMINT);
		map.put("Rdm", Mnemonic.RDM);
		map.put("Svdc", Mnemonic.SVDC);
		map.put("Rsdc", Mnemonic.RSDC);
		map.put("Svldt", Mnemonic.SVLDT);
		map.put("Rsldt", Mnemonic.RSLDT);
		map.put("Svts", Mnemonic.SVTS);
		map.put("Rsts", Mnemonic.RSTS);
		map.put("Bb0_reset", Mnemonic.BB0_RESET);
		map.put("Bb1_reset", Mnemonic.BB1_RESET);
		map.put("Cpu_write", Mnemonic.CPU_WRITE);
		map.put("Cpu_read", Mnemonic.CPU_READ);
		map.put("Altinst", Mnemonic.ALTINST);
		map.put("Paveb", Mnemonic.PAVEB);
		map.put("Paddsiw", Mnemonic.PADDSIW);
		map.put("Pmagw", Mnemonic.PMAGW);
		map.put("Pdistib", Mnemonic.PDISTIB);
		map.put("Psubsiw", Mnemonic.PSUBSIW);
		map.put("Pmvzb", Mnemonic.PMVZB);
		map.put("Pmvnzb", Mnemonic.PMVNZB);
		map.put("Pmvlzb", Mnemonic.PMVLZB);
		map.put("Pmvgezb", Mnemonic.PMVGEZB);
		map.put("Pmulhriw", Mnemonic.PMULHRIW);
		map.put("Pmachriw", Mnemonic.PMACHRIW);
		map.put("Ftstp", Mnemonic.FTSTP);
		map.put("Frint2", Mnemonic.FRINT2);
		map.put("Frichop", Mnemonic.FRICHOP);
		map.put("Frinear", Mnemonic.FRINEAR);
		map.put("Undoc", Mnemonic.UNDOC);
		map.put("Tdcall", Mnemonic.TDCALL);
		map.put("Seamret", Mnemonic.SEAMRET);
		map.put("Seamops", Mnemonic.SEAMOPS);
		map.put("Seamcall", Mnemonic.SEAMCALL);
		map.put("Aesencwide128kl", Mnemonic.AESENCWIDE128KL);
		map.put("Aesdecwide128kl", Mnemonic.AESDECWIDE128KL);
		map.put("Aesencwide256kl", Mnemonic.AESENCWIDE256KL);
		map.put("Aesdecwide256kl", Mnemonic.AESDECWIDE256KL);
		map.put("Loadiwkey", Mnemonic.LOADIWKEY);
		map.put("Aesenc128kl", Mnemonic.AESENC128KL);
		map.put("Aesdec128kl", Mnemonic.AESDEC128KL);
		map.put("Aesenc256kl", Mnemonic.AESENC256KL);
		map.put("Aesdec256kl", Mnemonic.AESDEC256KL);
		map.put("Encodekey128", Mnemonic.ENCODEKEY128);
		map.put("Encodekey256", Mnemonic.ENCODEKEY256);
		map.put("Pushad", Mnemonic.PUSHAD);
		map.put("Popad", Mnemonic.POPAD);
		map.put("Pushfd", Mnemonic.PUSHFD);
		map.put("Pushfq", Mnemonic.PUSHFQ);
		map.put("Popfd", Mnemonic.POPFD);
		map.put("Popfq", Mnemonic.POPFQ);
		map.put("Iretd", Mnemonic.IRETD);
		map.put("Iretq", Mnemonic.IRETQ);
		map.put("Int3", Mnemonic.INT3);
		map.put("Uiret", Mnemonic.UIRET);
		map.put("Testui", Mnemonic.TESTUI);
		map.put("Clui", Mnemonic.CLUI);
		map.put("Stui", Mnemonic.STUI);
		map.put("Senduipi", Mnemonic.SENDUIPI);
		map.put("Hreset", Mnemonic.HRESET);
		map.put("Ccs_hash", Mnemonic.CCS_HASH);
		map.put("Ccs_encrypt", Mnemonic.CCS_ENCRYPT);
		map.put("Lkgs", Mnemonic.LKGS);
		map.put("Eretu", Mnemonic.ERETU);
		map.put("Erets", Mnemonic.ERETS);
		map.put("Storeall", Mnemonic.STOREALL);
		map.put("Vaddph", Mnemonic.VADDPH);
		map.put("Vaddsh", Mnemonic.VADDSH);
		map.put("Vcmpph", Mnemonic.VCMPPH);
		map.put("Vcmpsh", Mnemonic.VCMPSH);
		map.put("Vcomish", Mnemonic.VCOMISH);
		map.put("Vcvtdq2ph", Mnemonic.VCVTDQ2PH);
		map.put("Vcvtpd2ph", Mnemonic.VCVTPD2PH);
		map.put("Vcvtph2dq", Mnemonic.VCVTPH2DQ);
		map.put("Vcvtph2pd", Mnemonic.VCVTPH2PD);
		map.put("Vcvtph2psx", Mnemonic.VCVTPH2PSX);
		map.put("Vcvtph2qq", Mnemonic.VCVTPH2QQ);
		map.put("Vcvtph2udq", Mnemonic.VCVTPH2UDQ);
		map.put("Vcvtph2uqq", Mnemonic.VCVTPH2UQQ);
		map.put("Vcvtph2uw", Mnemonic.VCVTPH2UW);
		map.put("Vcvtph2w", Mnemonic.VCVTPH2W);
		map.put("Vcvtps2phx", Mnemonic.VCVTPS2PHX);
		map.put("Vcvtqq2ph", Mnemonic.VCVTQQ2PH);
		map.put("Vcvtsd2sh", Mnemonic.VCVTSD2SH);
		map.put("Vcvtsh2sd", Mnemonic.VCVTSH2SD);
		map.put("Vcvtsh2si", Mnemonic.VCVTSH2SI);
		map.put("Vcvtsh2ss", Mnemonic.VCVTSH2SS);
		map.put("Vcvtsh2usi", Mnemonic.VCVTSH2USI);
		map.put("Vcvtsi2sh", Mnemonic.VCVTSI2SH);
		map.put("Vcvtss2sh", Mnemonic.VCVTSS2SH);
		map.put("Vcvttph2dq", Mnemonic.VCVTTPH2DQ);
		map.put("Vcvttph2qq", Mnemonic.VCVTTPH2QQ);
		map.put("Vcvttph2udq", Mnemonic.VCVTTPH2UDQ);
		map.put("Vcvttph2uqq", Mnemonic.VCVTTPH2UQQ);
		map.put("Vcvttph2uw", Mnemonic.VCVTTPH2UW);
		map.put("Vcvttph2w", Mnemonic.VCVTTPH2W);
		map.put("Vcvttsh2si", Mnemonic.VCVTTSH2SI);
		map.put("Vcvttsh2usi", Mnemonic.VCVTTSH2USI);
		map.put("Vcvtudq2ph", Mnemonic.VCVTUDQ2PH);
		map.put("Vcvtuqq2ph", Mnemonic.VCVTUQQ2PH);
		map.put("Vcvtusi2sh", Mnemonic.VCVTUSI2SH);
		map.put("Vcvtuw2ph", Mnemonic.VCVTUW2PH);
		map.put("Vcvtw2ph", Mnemonic.VCVTW2PH);
		map.put("Vdivph", Mnemonic.VDIVPH);
		map.put("Vdivsh", Mnemonic.VDIVSH);
		map.put("Vfcmaddcph", Mnemonic.VFCMADDCPH);
		map.put("Vfmaddcph", Mnemonic.VFMADDCPH);
		map.put("Vfcmaddcsh", Mnemonic.VFCMADDCSH);
		map.put("Vfmaddcsh", Mnemonic.VFMADDCSH);
		map.put("Vfcmulcph", Mnemonic.VFCMULCPH);
		map.put("Vfmulcph", Mnemonic.VFMULCPH);
		map.put("Vfcmulcsh", Mnemonic.VFCMULCSH);
		map.put("Vfmulcsh", Mnemonic.VFMULCSH);
		map.put("Vfmaddsub132ph", Mnemonic.VFMADDSUB132PH);
		map.put("Vfmaddsub213ph", Mnemonic.VFMADDSUB213PH);
		map.put("Vfmaddsub231ph", Mnemonic.VFMADDSUB231PH);
		map.put("Vfmsubadd132ph", Mnemonic.VFMSUBADD132PH);
		map.put("Vfmsubadd213ph", Mnemonic.VFMSUBADD213PH);
		map.put("Vfmsubadd231ph", Mnemonic.VFMSUBADD231PH);
		map.put("Vfmadd132ph", Mnemonic.VFMADD132PH);
		map.put("Vfmadd213ph", Mnemonic.VFMADD213PH);
		map.put("Vfmadd231ph", Mnemonic.VFMADD231PH);
		map.put("Vfnmadd132ph", Mnemonic.VFNMADD132PH);
		map.put("Vfnmadd213ph", Mnemonic.VFNMADD213PH);
		map.put("Vfnmadd231ph", Mnemonic.VFNMADD231PH);
		map.put("Vfmadd132sh", Mnemonic.VFMADD132SH);
		map.put("Vfmadd213sh", Mnemonic.VFMADD213SH);
		map.put("Vfmadd231sh", Mnemonic.VFMADD231SH);
		map.put("Vfnmadd132sh", Mnemonic.VFNMADD132SH);
		map.put("Vfnmadd213sh", Mnemonic.VFNMADD213SH);
		map.put("Vfnmadd231sh", Mnemonic.VFNMADD231SH);
		map.put("Vfmsub132ph", Mnemonic.VFMSUB132PH);
		map.put("Vfmsub213ph", Mnemonic.VFMSUB213PH);
		map.put("Vfmsub231ph", Mnemonic.VFMSUB231PH);
		map.put("Vfnmsub132ph", Mnemonic.VFNMSUB132PH);
		map.put("Vfnmsub213ph", Mnemonic.VFNMSUB213PH);
		map.put("Vfnmsub231ph", Mnemonic.VFNMSUB231PH);
		map.put("Vfmsub132sh", Mnemonic.VFMSUB132SH);
		map.put("Vfmsub213sh", Mnemonic.VFMSUB213SH);
		map.put("Vfmsub231sh", Mnemonic.VFMSUB231SH);
		map.put("Vfnmsub132sh", Mnemonic.VFNMSUB132SH);
		map.put("Vfnmsub213sh", Mnemonic.VFNMSUB213SH);
		map.put("Vfnmsub231sh", Mnemonic.VFNMSUB231SH);
		map.put("Vfpclassph", Mnemonic.VFPCLASSPH);
		map.put("Vfpclasssh", Mnemonic.VFPCLASSSH);
		map.put("Vgetexpph", Mnemonic.VGETEXPPH);
		map.put("Vgetexpsh", Mnemonic.VGETEXPSH);
		map.put("Vgetmantph", Mnemonic.VGETMANTPH);
		map.put("Vgetmantsh", Mnemonic.VGETMANTSH);
		map.put("Vmaxph", Mnemonic.VMAXPH);
		map.put("Vmaxsh", Mnemonic.VMAXSH);
		map.put("Vminph", Mnemonic.VMINPH);
		map.put("Vminsh", Mnemonic.VMINSH);
		map.put("Vmovsh", Mnemonic.VMOVSH);
		map.put("Vmovw", Mnemonic.VMOVW);
		map.put("Vmulph", Mnemonic.VMULPH);
		map.put("Vmulsh", Mnemonic.VMULSH);
		map.put("Vrcpph", Mnemonic.VRCPPH);
		map.put("Vrcpsh", Mnemonic.VRCPSH);
		map.put("Vreduceph", Mnemonic.VREDUCEPH);
		map.put("Vreducesh", Mnemonic.VREDUCESH);
		map.put("Vrndscaleph", Mnemonic.VRNDSCALEPH);
		map.put("Vrndscalesh", Mnemonic.VRNDSCALESH);
		map.put("Vrsqrtph", Mnemonic.VRSQRTPH);
		map.put("Vrsqrtsh", Mnemonic.VRSQRTSH);
		map.put("Vscalefph", Mnemonic.VSCALEFPH);
		map.put("Vscalefsh", Mnemonic.VSCALEFSH);
		map.put("Vsqrtph", Mnemonic.VSQRTPH);
		map.put("Vsqrtsh", Mnemonic.VSQRTSH);
		map.put("Vsubph", Mnemonic.VSUBPH);
		map.put("Vsubsh", Mnemonic.VSUBSH);
		map.put("Vucomish", Mnemonic.VUCOMISH);
		map.put("Rdudbg", Mnemonic.RDUDBG);
		map.put("Wrudbg", Mnemonic.WRUDBG);
		map.put("Clevict0", Mnemonic.CLEVICT0);
		map.put("Clevict1", Mnemonic.CLEVICT1);
		map.put("Delay", Mnemonic.DELAY);
		map.put("Jknzd", Mnemonic.JKNZD);
		map.put("Jkzd", Mnemonic.JKZD);
		map.put("Kand", Mnemonic.KAND);
		map.put("Kandn", Mnemonic.KANDN);
		map.put("Kandnr", Mnemonic.KANDNR);
		map.put("Kconcath", Mnemonic.KCONCATH);
		map.put("Kconcatl", Mnemonic.KCONCATL);
		map.put("Kextract", Mnemonic.KEXTRACT);
		map.put("Kmerge2l1h", Mnemonic.KMERGE2L1H);
		map.put("Kmerge2l1l", Mnemonic.KMERGE2L1L);
		map.put("Kmov", Mnemonic.KMOV);
		map.put("Knot", Mnemonic.KNOT);
		map.put("Kor", Mnemonic.KOR);
		map.put("Kortest", Mnemonic.KORTEST);
		map.put("Kxnor", Mnemonic.KXNOR);
		map.put("Kxor", Mnemonic.KXOR);
		map.put("Spflt", Mnemonic.SPFLT);
		map.put("Tzcnti", Mnemonic.TZCNTI);
		map.put("Vaddnpd", Mnemonic.VADDNPD);
		map.put("Vaddnps", Mnemonic.VADDNPS);
		map.put("Vaddsetsps", Mnemonic.VADDSETSPS);
		map.put("Vcvtfxpntdq2ps", Mnemonic.VCVTFXPNTDQ2PS);
		map.put("Vcvtfxpntpd2dq", Mnemonic.VCVTFXPNTPD2DQ);
		map.put("Vcvtfxpntpd2udq", Mnemonic.VCVTFXPNTPD2UDQ);
		map.put("Vcvtfxpntps2dq", Mnemonic.VCVTFXPNTPS2DQ);
		map.put("Vcvtfxpntps2udq", Mnemonic.VCVTFXPNTPS2UDQ);
		map.put("Vcvtfxpntudq2ps", Mnemonic.VCVTFXPNTUDQ2PS);
		map.put("Vexp223ps", Mnemonic.VEXP223PS);
		map.put("Vfixupnanpd", Mnemonic.VFIXUPNANPD);
		map.put("Vfixupnanps", Mnemonic.VFIXUPNANPS);
		map.put("Vfmadd233ps", Mnemonic.VFMADD233PS);
		map.put("Vgatherpf0hintdpd", Mnemonic.VGATHERPF0HINTDPD);
		map.put("Vgatherpf0hintdps", Mnemonic.VGATHERPF0HINTDPS);
		map.put("Vgmaxabsps", Mnemonic.VGMAXABSPS);
		map.put("Vgmaxpd", Mnemonic.VGMAXPD);
		map.put("Vgmaxps", Mnemonic.VGMAXPS);
		map.put("Vgminpd", Mnemonic.VGMINPD);
		map.put("Vgminps", Mnemonic.VGMINPS);
		map.put("Vloadunpackhd", Mnemonic.VLOADUNPACKHD);
		map.put("Vloadunpackhpd", Mnemonic.VLOADUNPACKHPD);
		map.put("Vloadunpackhps", Mnemonic.VLOADUNPACKHPS);
		map.put("Vloadunpackhq", Mnemonic.VLOADUNPACKHQ);
		map.put("Vloadunpackld", Mnemonic.VLOADUNPACKLD);
		map.put("Vloadunpacklpd", Mnemonic.VLOADUNPACKLPD);
		map.put("Vloadunpacklps", Mnemonic.VLOADUNPACKLPS);
		map.put("Vloadunpacklq", Mnemonic.VLOADUNPACKLQ);
		map.put("Vlog2ps", Mnemonic.VLOG2PS);
		map.put("Vmovnrapd", Mnemonic.VMOVNRAPD);
		map.put("Vmovnraps", Mnemonic.VMOVNRAPS);
		map.put("Vmovnrngoapd", Mnemonic.VMOVNRNGOAPD);
		map.put("Vmovnrngoaps", Mnemonic.VMOVNRNGOAPS);
		map.put("Vpackstorehd", Mnemonic.VPACKSTOREHD);
		map.put("Vpackstorehpd", Mnemonic.VPACKSTOREHPD);
		map.put("Vpackstorehps", Mnemonic.VPACKSTOREHPS);
		map.put("Vpackstorehq", Mnemonic.VPACKSTOREHQ);
		map.put("Vpackstoreld", Mnemonic.VPACKSTORELD);
		map.put("Vpackstorelpd", Mnemonic.VPACKSTORELPD);
		map.put("Vpackstorelps", Mnemonic.VPACKSTORELPS);
		map.put("Vpackstorelq", Mnemonic.VPACKSTORELQ);
		map.put("Vpadcd", Mnemonic.VPADCD);
		map.put("Vpaddsetcd", Mnemonic.VPADDSETCD);
		map.put("Vpaddsetsd", Mnemonic.VPADDSETSD);
		map.put("Vpcmpltd", Mnemonic.VPCMPLTD);
		map.put("Vpermf32x4", Mnemonic.VPERMF32X4);
		map.put("Vpmadd231d", Mnemonic.VPMADD231D);
		map.put("Vpmadd233d", Mnemonic.VPMADD233D);
		map.put("Vpmulhd", Mnemonic.VPMULHD);
		map.put("Vpmulhud", Mnemonic.VPMULHUD);
		map.put("Vprefetch0", Mnemonic.VPREFETCH0);
		map.put("Vprefetch1", Mnemonic.VPREFETCH1);
		map.put("Vprefetch2", Mnemonic.VPREFETCH2);
		map.put("Vprefetche0", Mnemonic.VPREFETCHE0);
		map.put("Vprefetche1", Mnemonic.VPREFETCHE1);
		map.put("Vprefetche2", Mnemonic.VPREFETCHE2);
		map.put("Vprefetchenta", Mnemonic.VPREFETCHENTA);
		map.put("Vprefetchnta", Mnemonic.VPREFETCHNTA);
		map.put("Vpsbbd", Mnemonic.VPSBBD);
		map.put("Vpsbbrd", Mnemonic.VPSBBRD);
		map.put("Vpsubrd", Mnemonic.VPSUBRD);
		map.put("Vpsubrsetbd", Mnemonic.VPSUBRSETBD);
		map.put("Vpsubsetbd", Mnemonic.VPSUBSETBD);
		map.put("Vrcp23ps", Mnemonic.VRCP23PS);
		map.put("Vrndfxpntpd", Mnemonic.VRNDFXPNTPD);
		map.put("Vrndfxpntps", Mnemonic.VRNDFXPNTPS);
		map.put("Vrsqrt23ps", Mnemonic.VRSQRT23PS);
		map.put("Vscaleps", Mnemonic.VSCALEPS);
		map.put("Vscatterpf0hintdpd", Mnemonic.VSCATTERPF0HINTDPD);
		map.put("Vscatterpf0hintdps", Mnemonic.VSCATTERPF0HINTDPS);
		map.put("Vsubrpd", Mnemonic.VSUBRPD);
		map.put("Vsubrps", Mnemonic.VSUBRPS);
		map.put("Xsha512", Mnemonic.XSHA512);
		map.put("Xstore_alt", Mnemonic.XSTORE_ALT);
		map.put("Xsha512_alt", Mnemonic.XSHA512_ALT);
		map.put("Zero_bytes", Mnemonic.ZERO_BYTES);
		map.put("Aadd", Mnemonic.AADD);
		map.put("Aand", Mnemonic.AAND);
		map.put("Aor", Mnemonic.AOR);
		map.put("Axor", Mnemonic.AXOR);
		map.put("Cmpbexadd", Mnemonic.CMPBEXADD);
		map.put("Cmpbxadd", Mnemonic.CMPBXADD);
		map.put("Cmplexadd", Mnemonic.CMPLEXADD);
		map.put("Cmplxadd", Mnemonic.CMPLXADD);
		map.put("Cmpnbexadd", Mnemonic.CMPNBEXADD);
		map.put("Cmpnbxadd", Mnemonic.CMPNBXADD);
		map.put("Cmpnlexadd", Mnemonic.CMPNLEXADD);
		map.put("Cmpnlxadd", Mnemonic.CMPNLXADD);
		map.put("Cmpnoxadd", Mnemonic.CMPNOXADD);
		map.put("Cmpnpxadd", Mnemonic.CMPNPXADD);
		map.put("Cmpnsxadd", Mnemonic.CMPNSXADD);
		map.put("Cmpnzxadd", Mnemonic.CMPNZXADD);
		map.put("Cmpoxadd", Mnemonic.CMPOXADD);
		map.put("Cmppxadd", Mnemonic.CMPPXADD);
		map.put("Cmpsxadd", Mnemonic.CMPSXADD);
		map.put("Cmpzxadd", Mnemonic.CMPZXADD);
		map.put("Prefetchit0", Mnemonic.PREFETCHIT0);
		map.put("Prefetchit1", Mnemonic.PREFETCHIT1);
		map.put("Rdmsrlist", Mnemonic.RDMSRLIST);
		map.put("Rmpquery", Mnemonic.RMPQUERY);
		map.put("Tdpfp16ps", Mnemonic.TDPFP16PS);
		map.put("Vbcstnebf162ps", Mnemonic.VBCSTNEBF162PS);
		map.put("Vbcstnesh2ps", Mnemonic.VBCSTNESH2PS);
		map.put("Vcvtneebf162ps", Mnemonic.VCVTNEEBF162PS);
		map.put("Vcvtneeph2ps", Mnemonic.VCVTNEEPH2PS);
		map.put("Vcvtneobf162ps", Mnemonic.VCVTNEOBF162PS);
		map.put("Vcvtneoph2ps", Mnemonic.VCVTNEOPH2PS);
		map.put("Vpdpbssd", Mnemonic.VPDPBSSD);
		map.put("Vpdpbssds", Mnemonic.VPDPBSSDS);
		map.put("Vpdpbsud", Mnemonic.VPDPBSUD);
		map.put("Vpdpbsuds", Mnemonic.VPDPBSUDS);
		map.put("Vpdpbuud", Mnemonic.VPDPBUUD);
		map.put("Vpdpbuuds", Mnemonic.VPDPBUUDS);
		map.put("Wrmsrlist", Mnemonic.WRMSRLIST);
		map.put("Wrmsrns", Mnemonic.WRMSRNS);
	}
}
