// SPDX-License-Identifier: MIT
// Copyright (C) 2018-present iced project and contributors

// ⚠️This file was generated by GENERATOR!🦹‍♂️

package com.github.icedland.iced.x86.info;

import java.util.HashMap;

import com.github.icedland.iced.x86.EncodingKind;

final class OpCodeInfoDicts {
	static final HashMap<String, Integer> toEncodingKind = createEncodingKind();
	private static HashMap<String, Integer> createEncodingKind() {
		HashMap<String, Integer> map = new HashMap<String, Integer>(6);
		map.put("legacy", EncodingKind.LEGACY);
		map.put("VEX", EncodingKind.VEX);
		map.put("EVEX", EncodingKind.EVEX);
		map.put("XOP", EncodingKind.XOP);
		map.put("3DNow!", EncodingKind.D3NOW);
		map.put("MVEX", EncodingKind.MVEX);
		return map;
	}

	static final HashMap<String, Integer> toMandatoryPrefix = createMandatoryPrefix();
	private static HashMap<String, Integer> createMandatoryPrefix() {
		HashMap<String, Integer> map = new HashMap<String, Integer>(5);
		map.put("", MandatoryPrefix.NONE);
		map.put("NP", MandatoryPrefix.PNP);
		map.put("66", MandatoryPrefix.P66);
		map.put("F3", MandatoryPrefix.PF3);
		map.put("F2", MandatoryPrefix.PF2);
		return map;
	}

	static final HashMap<String, Integer> toOpCodeTableKind = createOpCodeTableKind();
	private static HashMap<String, Integer> createOpCodeTableKind() {
		HashMap<String, Integer> map = new HashMap<String, Integer>(9);
		map.put("legacy", OpCodeTableKind.NORMAL);
		map.put("0F", OpCodeTableKind.T0F);
		map.put("0F38", OpCodeTableKind.T0F38);
		map.put("0F3A", OpCodeTableKind.T0F3A);
		map.put("MAP5", OpCodeTableKind.MAP5);
		map.put("MAP6", OpCodeTableKind.MAP6);
		map.put("X8", OpCodeTableKind.MAP8);
		map.put("X9", OpCodeTableKind.MAP9);
		map.put("XA", OpCodeTableKind.MAP10);
		return map;
	}
}
